@echo off
SETLOCAL
SET CURR_DIR=%~dp0

SET LOG=
SET DB_NAME=
SET INST_HOME=
SET RC=

SET LOG=%~1
SET DB_NAME=%~2
SET INST_HOME=%~3
SET RC=0

if "%LOG%"=="" (
	set LOG="%CURR_DIR%\DB2TAkeOver.log"
) else (
	set LOG="%CURR_DIR%\%LOG%"
)

if "%DB_NAME%"=="" (
	echo. > %LOG%
	echo DB_NAME Property is empty. >> %LOG%
	SET RC=-1
	goto printUsage
)

if "%INST_HOME%"=="" (
	echo. 
	echo INST_HOME Property is empty. >> %LOG%
	SET RC=-1
	goto printUsage
)

if "%INST_HOME%"=="" (
	echo.
	echo INST_HOME Property is empty. >> %LOG%
	SET RC=-1
	goto printUsage
)

if not exist "%INST_HOME%" (
	echo Invalid INST_HOME directory set. >> %LOG%
	SET RC=-1
	goto end
)

cd "%INST_HOME%\bin" 
rem echo db2 takeover hadr on database %DB_NAME% by force
db2cmd /w /c /i db2 activate database %DB_NAME%
db2cmd /w /c /i db2 takeover hadr on database %DB_NAME% by force
SET RC=%ERRORLEVEL%
echo error code %RC% >> %LOG%
if %RC%==0 (
	echo Takeover process successful. >> %LOG%
) else (
	echo Takeover process failed. >> %LOG%
)
goto end

:printUsage
echo Usage DB2TakeOver.bat <LOG> <DB_NAME> <INST_HOME> >> %LOG%
echo LOG : Log file path >> %LOG%
echo DB_NAME : DB2 database name >> %LOG%
echo INST_HOME : DB2 instance home  >> %LOG%
goto end 

:end
cd "%CURR_DIR%"
exit /B %RC%