#!/bin/bash
#set -x
#
# Licensed Materials-Property of IBM
# (C)Copyright IBM Corp 2008
# All rights reserved
# US Government Users Restricted Rights
# Use, duplication, or disclosure restricted
# by GSA ADP Schedule Contract with IBM Corp
# 
# The script is to be called from the IBM Tivoli Key Life Cycle Manager 
# Installer
#
# arg1 -  log  -   log file to be used by this script  
# arg2 -  dbname  -  database name
# arg3 -  dbinstance_owner_home - home of the instance owner  
#  Note:  The script 
#	        must be run on the same machine where DB2 server is installed.
#		does do not parameter validation
#
#------------------------------------------------------------------------------

LOG=$1
DB_NAME=$2
INST_HOME=$3

#temporary return code
dbrc=0

if [ $# -ne 3 ]
then
echo Usage: db2takeover.sh logfile dbinstance dbname dbinstance_owner_home
    exit 2
fi


##################################################################
echo "---------------------------------------------------------------------------------------------------" >> $LOG
echo Started executing db2takeover.sh >> "$LOG"
echo "---------------------------------------------------------------------------------------------------" >> $LOG

CURRENT_DIR=`dirname $0`
if [ "$CURRENT_DIR" = "." ]; then
   CURRENT_DIR=`pwd`
fi

# set instance profile path to source profile of local instance
#source $DB_INST/db2profile
echo . $INST_HOME/sqllib/db2profile >> "$LOG" 
. $INST_HOME/sqllib/db2profile
rc=$?
if [ $rc -eq 0 ]; then
	echo Db2 profile loaded.
	echo Performing takeover operation.
	db2 activate database $DB_NAME
	echo db2 takeover hadr on database $DB_NAME by force 
	db2 takeover hadr on database $DB_NAME by force 
	dbrc=$?
fi
if [ $dbrc -eq 0 ]; then
	echo Takeover successful.
	rc=0
fi
exit $rc