@echo off

SETLOCAL
 
SET CURR_DIR=%~dp0

if [%6]==[] (
    goto usage
)

goto setvar

:USAGE
echo Usage: 
echo		agentImportKS.bat [Path to WAS_HOME] [KS_TYPE] [KS_PATH] [KS_PASSWORD] [SKLMADMIN_USERNAME] [SKLMADMIN_PASSWORD] [ALIAS_NAME]
echo        ALIAS_NAME is optional and required if there are multiple alias entries in Keystore
echo Example: 
echo		agentImportKS.bat "C:\Program Files\IBM\WebSphere\AppServer" "JCEKS" "c:\thirdparty.jceks" "keystore_password" sklmadmin sklmadmin_password
echo Note:	Please ensure the WAS HOME path is correct.			
goto end

goto end


:SETVAR

SET WAS_HOME=%~1
SET KS_TYPE=%~2
SET KS_PATH=%~3
SET KS_PASSWORD=%~4
SET SKLMADMIN_USERNAME=%~5
SET SKLMADMIN_PASSWORD=%~6

SET ALIAS_NAME=

if not [%7]==[] (
	SET ALIAS_NAME=%~7
)

echo %WAS_HOME%
::Validate WAS_HOME availability
if not exist "%WAS_HOME%" (
	echo.
	echo WAS_HOME Path not Valid.
	goto end
)

:: Validate all the Inputs
if "%KS_TYPE%"=="" (
	echo.
	echo KS_TYPE property is empty.
	goto end
)

if "%KS_PATH%"=="" (
	echo.
	echo KS_PATH Property is empty.
	goto end
)

if "%KS_PASSWORD%"=="" (
	echo.
	echo KS_PASSWORD Property is empty.
	goto end
)

if "%SKLMADMIN_USERNAME%"=="" (
	echo.
	echo SKLMADMIN_USERNAME Property is empty.
	goto end
)

if "%SKLMADMIN_PASSWORD%"=="" (
	echo.
	echo SKLMADMIN_PASSWORD Property is empty.
	goto end
)

echo.
SET AGENT_CP=%CURR_DIR%com.ibm.sklm.agent.jar;%WAS_HOME%/runtimes/com.ibm.ws.admin.client_9.0.jar;%WAS_HOME%/lib/ext/com.ibm.tklm.obfuscation.jar;%WAS_HOME%/plugins/com.ibm.ws.runtime.jar;%WAS_HOME%/universalDriver/lib/db2jcc4.jar;%WAS_HOME%/universalDriver/lib/db2jcc_license_cu.jar;%WAS_HOME%/lib/j2ee.jar;%WAS_HOME%/plugins/com.ibm.icu.jar;%WAS_HOME%/plugins/com.ibm.tklm.commands.jar;%WAS_HOME%/java/jre/lib/ext/ibmkeycert.jar;%WAS_HOME%/java/jre/lib/ext/ibmpkcs11impl.jar;%WAS_HOME%/java/jre/lib/ext/ibmjcefips.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.jar;%WAS_HOME%/plugins/org.eclipse.emf.common.jar;%WAS_HOME%/plugins/org.eclipse.emf.commonj.sdo.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.sdo.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.xmi.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.change.jar;%WAS_HOME%/runtimes/com.ibm.jaxws.thinclient_9.0.jar
rem echo %AGENT_CP%
call :AGENT_CLASSPATH


"%WAS_HOME%/java/8.0/bin/java.exe" -cp "%AGENT_CP%" com.ibm.sklm.agent.utilities.SKLMImportKS  %KS_TYPE% "%KS_PATH%" %KS_PASSWORD% %SKLMADMIN_USERNAME% %SKLMADMIN_PASSWORD% %ALIAS_NAME% > agentImportKS.log 2>&1

set rc=%ERRORLEVEL%
if NOT %rc%==0 (
	echo  Keystore import failed.
	echo Please check agentImportKS.log for more details.
)
if %rc%==0 (
	echo Keystore import successful.
)
goto end

:AGENT_CLASSPATH
for %%i in ("%WAS_HOME%\profiles\KLMProfile\installedApps\SKLMCell\sklm_kms.ear\*.jar") do call :SETCP %%i
for %%i in ("%WAS_HOME%\profiles\KLMProfile\installedApps\SKLMCell\sklm_kms.ear\lib\*.jar") do call :SETCP %%i
for %%i in ("%WAS_HOME%\lib\*.jar") do call :SETCP %%i


:SETCP
set AGENT_CP=%AGENT_CP%;%*


:end
exit /B 0
