#!/bin/bash
SCRIPTDIR=`dirname $0`
CURDIR=`pwd`
USRID=`id -u`
GID=`id -g`
cd $SCRIPTDIR
SCRIPTDIR=`pwd`
cd ..

cd $CURDIR
#echo $USRID

if [ ! $1 ]
then
echo Usage: 
echo		agentStarter.sh "<Path to WAS_HOME>"
echo		where
echo		the Input Parameter is the path to WAS_HOME.
echo Example: 
echo		agentStarter.sh "/opt/IBM/WebSphere/AppServer"
echo Note:	Please ensure the WAS HOME path is correct.
exit 1
fi

export WAS_HOME=$1

if [ -f $WAS_HOME/properties/sklm.properties  ]; then
	#echo TKLM_DB_ADMIN = $TKLM_DB_ADMIN	
	#echo loading $WAS_HOME/properties/sklm.properties
	. $WAS_HOME/properties/sklm.properties
fi

if [ $GID -eq 0  ]; then
	if [ "$TKLM_DB_ADMIN" =  "" ]; then
   		echo "Cannot run this operation as a root user. Only the process owner user can run this operation."
   		exit 1
   	else
   		COMMAND="$SCRIPTDIR/startAgent.sh $@"
   		su - $TKLM_DB_ADMIN -c "$COMMAND"
	    RETVAL=$?	
	    chown ${TKLM_DB_ADMIN} $SCRIPTDIR/*.*
	    chown ${TKLM_DB_ADMIN} $WAS_HOME/products/sklm/logs/*.*
	fi	
else 
	$SCRIPTDIR/startAgent.sh "$@"
	RETVAL=$?
fi
exit $RETVAL