#!/bin/sh

CURR_DIR=`pwd`
CURR_DIR=${0%/*}
#echo "CURR_DIR=${CURR_DIR}"

export PATH=${PATH}:.

cd ${0%/*}

ARGS_COUNT=$#
if [ ${ARGS_COUNT} -lt 2 -o ${ARGS_COUNT} -eq 3 -o ${ARGS_COUNT} -gt 4 ];
then
echo Usage: 
echo        configureKerberos.sh "<Path to WAS_HOME>"
echo        where
echo        the Input Parameter is the path to WAS_HOME.
echo Example: 
echo        configureKerberos.sh "/opt/IBM/WebSphere/AppServer"
echo Note:  Please ensure the WAS HOME path is correct.
exit 1
fi

export WAS_HOME=$1
export PROPERTIES=$2

if [ ! -d ${WAS_HOME} ]
then
echo "WAS_HOME Path Invalid"
exit 1
else
export JAVA_HOME=${WAS_HOME}/java/8.0   
fi


AGENT_CP=${CURR_DIR}/com.ibm.sklm.agent.jar:${WAS_HOME}/runtimes/com.ibm.ws.admin.client_9.0.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.obfuscation.jar:${WAS_HOME}/universalDriver/lib/db2jcc4.jar:${WAS_HOME}/universalDriver/lib/db2jcc_license_cu.jar:${WAS_HOME}/lib/j2ee.jar:${WAS_HOME}/plugins/com.ibm.icu.jar:${WAS_HOME}/plugins/com.ibm.tklm.commands.jar:${WAS_HOME}/java/jre/lib/ext/ibmkeycert.jar:${WAS_HOME}/java/jre/lib/ext/ibmpkcs11impl.jar:${WAS_HOME}/java/jre/lib/ext/ibmjcefips.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.passwordpolicy.jar

#echo "****** AGENT_CP ${AGENT_CP}*******"

shopt -s nullglob
for f in ${WAS_HOME}/plugins/*.jar
do
    AGENT_CP=${AGENT_CP}:$f
done
for f in ${WAS_HOME}/lib/*.jar
do
    AGENT_CP=${AGENT_CP}:$f
done
for f in ${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/*.jar
do
    AGENT_CP=${AGENT_CP}:$f
done
for f in ${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/lib/*.jar
do
    AGENT_CP=${AGENT_CP}:$f
done

${JAVA_HOME}/bin/java -cp ${AGENT_CP} com.ibm.sklm.agent.AgentConfigureKerberos ${PROPERTIES}
rc=$?
if [ $rc -eq 0 ]; then
    echo "Kerberos Configuration successful."
else
    echo "Kerberos Configuration failed."
fi

exit $rc
