@echo off
SET CURR_DIR=%~dp0
rem echo CURR_DIR %CURR_DIR%
:: Keep variables local
SETLOCAL
SET WAS_HOME=
SET DB_PASSWORD=

if not exist revertMasterToStandalone.properties goto noconfig

for /f "tokens=1,2,3 delims==" %%a in (revertMasterToStandalone.properties) do (
  
  if "%%a"=="WAS_HOME" set WAS_HOME=%%b
  if "%%a"=="WAS_USER_PWD" set WAS_USER_PWD=%%b
  if "%%a"=="DB_PASSWORD" set DB_PASSWORD=%%b
  if "%%a"=="JAVA_HOME" set JAVA_HOME=%%b
  )


if "%WAS_HOME%"=="" (
 echo.
 echo WAS_HOME Property is empty.
 goto end
)

if not exist "%WAS_HOME%/bin/wsadmin.bat" (
	echo.
	echo Invalid WAS_HOME directory set.
	goto end
)

if not "%JAVA_HOME%"=="" (
	if not exist "%JAVA_HOME%\\bin\\java.exe" (
	 echo.
	 echo Invalid JAVA_HOME directory set.
	 goto end	
	)
)

if "%WAS_USER_PWD%"=="" (
 echo.
 echo WAS_USER_PWD Property is empty.
 goto end
)


if "%DB_PASSWORD%"=="" (
 echo.
 echo DB_PASSWORD Property is empty.
 goto end
)

goto run

:noconfig
@echo Cannot find revertMasterToStandalone.properties. The parameter values cannot be determined. Run this script again by specifying the following parameters in UtilitiesConfig.properties
@echo WAS_HOME
@echo DB_PASSWORD
@echo WAS_USER_PWD
goto end
  
:run

echo.
SET RUNTIME_CP=%CURR_DIR%com.ibm.sklm.agent.jar;%WAS_HOME%/runtimes/com.ibm.ws.admin.client_9.0.jar;%WAS_HOME%/lib/ext/com.ibm.tklm.obfuscation.jar;%WAS_HOME%/plugins/com.ibm.ws.runtime.jar;%WAS_HOME%/universalDriver/lib/db2jcc4.jar;%WAS_HOME%/universalDriver/lib/db2jcc_license_cu.jar;%WAS_HOME%/lib/j2ee.jar;%WAS_HOME%/plugins/com.ibm.icu.jar;%WAS_HOME%/plugins/com.ibm.tklm.commands.jar;%WAS_HOME%/java/jre/lib/ext/ibmkeycert.jar;%WAS_HOME%/java/jre/lib/ext/ibmpkcs11impl.jar;%WAS_HOME%/java/jre/lib/ext/ibmjcefips.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.jar;%WAS_HOME%/plugins/org.eclipse.emf.common.jar;%WAS_HOME%/plugins/org.eclipse.emf.commonj.sdo.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.sdo.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.xmi.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.change.jar;


call :RUNTIME_CLASSPATH

if "%JAVA_HOME%"=="" (
"%WAS_HOME%/java/8.0/bin/java.exe" -cp "%RUNTIME_CP%" com.ibm.sklm.agent.master.utilities.executors.RevertMasterToStandaloneExecutor "%WAS_HOME%" 
) else (
"%JAVA_HOME%/bin/java.exe" -cp "%RUNTIME_CP%" com.ibm.sklm.agent.master.utilities.executors.RevertMasterToStandaloneExecutor "%WAS_HOME%" 
)
set rc=%ERRORLEVEL%
if %rc%==-1 (
	echo Revert Master To Standalone Failed with errors. Please check logs for details.
)
if %rc%==0 (
	echo Revert Master To Standalone is completed. Please check logs for more details.
)
if %rc%==2 (
	echo Exiting without reverting.
)
goto end

:RUNTIME_CLASSPATH
for %%i in ("%WAS_HOME%\profiles\KLMProfile\installedApps\SKLMCell\sklm_kms.ear\*.jar") do call :SETCP %%i
for %%i in ("%WAS_HOME%\profiles\KLMProfile\installedApps\SKLMCell\sklm_kms.ear\lib\*.jar") do call :SETCP %%i
for %%i in ("%WAS_HOME%\lib\*.jar") do call :SETCP %%i


:SETCP
set RUNTIME_CP=%RUNTIME_CP%;%*

:end