#!/bin/sh

CURR_DIR=`pwd`
CURR_DIR=${CURR_DIR}/
echo "CURR_DIR=${CURR_DIR}"

export PATH=${PATH}:.

if [ ! -f revertMasterToStandalone.properties ]
then
echo "Cannot find revertMasterToStandalone.properties. The parameter values cannot be determined. Run this script again by specifying the following parameters in revertMasterToStandalone.properties"
echo WAS_HOME
echo DB_PASSWORD
echo WAS_USER_PWD

exit 1
fi

. ./revertMasterToStandalone.properties

if [ -z ${WAS_HOME} ]
then 
echo "WAS_HOME Property is empty"
exit 1
fi

export WAS_HOME=${WAS_HOME}
if [ !  ${JAVA_HOME} ]
then
export JAVA_HOME=${WAS_HOME}/java/8.0
fi

if [ -z ${WAS_USER_PWD} ]
then 
echo "WAS_USER_PWD Property is empty"
exit 1
fi

if [ -z ${DB_PASSWORD} ]
then 
echo "DB_PASSWORD Property is empty"
exit 1
fi

if [ !  ${JAVA_HOME} ]
then
export JAVA_HOME=${WAS_HOME}/java/8.0
fi

if [ ! -d ${JAVA_HOME} ]
then
echo "JAVA_HOME ${JAVA_HOME} is not directory."
exit 1
fi


RUNTIME_CP=${CURR_DIR}/com.ibm.sklm.agent.jar:${WAS_HOME}/runtimes/com.ibm.ws.admin.client_9.0.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.obfuscation.jar:${WAS_HOME}/universalDriver/lib/db2jcc4.jar:${WAS_HOME}/universalDriver/lib/db2jcc_license_cu.jar:${WAS_HOME}/lib/j2ee.jar:${WAS_HOME}/plugins/com.ibm.icu.jar:${WAS_HOME}/plugins/com.ibm.tklm.commands.jar:${WAS_HOME}/java/jre/lib/ext/ibmkeycert.jar:${WAS_HOME}/java/jre/lib/ext/ibmpkcs11impl.jar:${WAS_HOME}/java/jre/lib/ext/ibmjcefips.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.passwordpolicy.jar

#echo "****** RUNTIME_CP ${RUNTIME_CP}*******"

shopt -s nullglob
for f in ${WAS_HOME}/plugins/*.jar
do
	RUNTIME_CP=${RUNTIME_CP}:$f
done
for f in ${WAS_HOME}/lib/*.jar
do
	RUNTIME_CP=${RUNTIME_CP}:$f
done
for f in ${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/*.jar
do
	RUNTIME_CP=${RUNTIME_CP}:$f
done
for f in ${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/lib/*.jar
do
    RUNTIME_CP=${RUNTIME_CP}:$f
done

#echo "****** RUNTIME_CP ${RUNTIME_CP}*******"

${JAVA_HOME}/bin/java -cp ${RUNTIME_CP} com.ibm.sklm.agent.master.utilities.executors.RevertMasterToStandaloneExecutor ${WAS_HOME}
rc=$?
if [ $rc -eq -1 ]; then
   	echo "Revert Master To Standalone Failed with errors. Please check logs for details."
else
 	if [ $rc -eq 0 ]; then
		echo "Revert Master To Standalone is completed. Please check logs for more details."
 	else
		 if [ $rc -eq 2 ]; then
			echo "Exiting without reverting."
		 fi
        fi
fi

exit 0
