@echo off

SETLOCAL
 
SET CURR_DIR=%~dp0

:: Keep Local Variables

echo starting sklmTakeoverHADR >  sklmTakeoverHADR.log 2>&1

SET SERVICE=
SET PRIMARY_DB_NAME=
SET PRIMARY_DB_USERNAME=
SET PRIMARY_DB_PASSWORD=
SET PRIMARY_DB_IP=
SET PRIMARY_DB_PORT=
SET STANDBY_DB_NAME=
SET STANDBY_DB_USERNAME=
SET STANDBY_DB_PASSWORD=
SET STANDBY_DB_IP=
SET STANDBY_DB_PORT=


cd %CURR_DIR%

if not exist agentStarter.properties goto noconfig

for /f "tokens=1,2,3 delims==" %%a in (agentStarter.properties) do (
	
	if "%%a"=="SERVICE" set SERVICE=%%b
	if "%%a"=="PRIMARY_DB_NAME" set PRIMARY_DB_NAME=%%b
	if "%%a"=="PRIMARY_DB_USERNAME" set PRIMARY_DB_USERNAME=%%b
	if "%%a"=="PRIMARY_DB_PASSWORD" set PRIMARY_DB_PASSWORD=%%b
	if "%%a"=="PRIMARY_DB_IP" set PRIMARY_DB_IP=%%b
	if "%%a"=="PRIMARY_DB_PORT" set PRIMARY_DB_PORT=%%b
	if "%%a"=="STANDBY_DB_NAME" set STANDBY_DB_NAME=%%b
	if "%%a"=="STANDBY_DB_USERNAME" set STANDBY_DB_USERNAME=%%b
	if "%%a"=="STANDBY_DB_PASSWORD" set STANDBY_DB_PASSWORD=%%b
	if "%%a"=="STANDBY_DB_IP" set STANDBY_DB_IP=%%b
	if "%%a"=="STANDBY_DB_PORT" set STANDBY_DB_PORT=%%b
)


if [%2] NEQ [] (
	if [%3] == [] goto printUsage
)


if [%4] NEQ [] (
	goto printUsage
)

goto validate

:printUsage
echo Usage: 
echo		sklmTakeoverHADR.bat "<Path to WAS_HOME>" [IP_HOSTNAME] [AGENT_PORT]
echo		where
echo		the Input Paramtere is the path to WAS_HOME,optional IP_HOSTNAME, optional AGENT_PORT
echo Example: 
echo		sklmTakeoverHADR.bat "C:\Program Files\IBM\WebSphere\AppServer"
echo 		OR
echo		sklmTakeoverHADR.bat "C:\Program Files\IBM\WebSphere\AppServer" hostname 60015
echo Note:	Please ensure the WAS HOME path, hostname and port is correct.			
goto end


:validate
SET WAS_HOME=%~1
SET IP_HOSTNAME=%~2
SET PORT=%~3

echo %WAS_HOME%
::Validate WAS_HOME availability
if not exist "%WAS_HOME%" (
	echo.
	echo WAS_HOME Path not Valid.
	goto end
)
goto run

:noconfig	
@echo Cannot find agentStarter.properties. The Parameter values cannot be determind. Please enter appropriate inputs before running this script again.	  
@WAS_HOME
@SERVICE
@PRIMARY_DB_NAME
@PRIMARY_DB_USERNAME
@PRIMARY_DB_PASSWORD
@PRIMARY_DB_IP
@PRIMARY_DB_PORT

goto end		 

:run
echo.
SET AGENT_CP=%CURR_DIR%com.ibm.sklm.agent.jar;%WAS_HOME%/runtimes/com.ibm.ws.admin.client_9.0.jar;%WAS_HOME%/lib/ext/com.ibm.tklm.obfuscation.jar;%WAS_HOME%/plugins/com.ibm.ws.runtime.jar;%WAS_HOME%/universalDriver/lib/db2jcc4.jar;%WAS_HOME%/universalDriver/lib/db2jcc_license_cu.jar;%WAS_HOME%/lib/j2ee.jar;%WAS_HOME%/plugins/com.ibm.icu.jar;%WAS_HOME%/plugins/com.ibm.tklm.commands.jar;%WAS_HOME%/java/jre/lib/ext/ibmkeycert.jar;%WAS_HOME%/java/jre/lib/ext/ibmpkcs11impl.jar;%WAS_HOME%/java/jre/lib/ext/ibmjcefips.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.jar;%WAS_HOME%/plugins/org.eclipse.emf.common.jar;%WAS_HOME%/plugins/org.eclipse.emf.commonj.sdo.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.sdo.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.xmi.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.change.jar;
rem echo %AGENT_CP%
call :AGENT_CLASSPATH
if "%JAVA_HOME%"=="" (
	"%WAS_HOME%/java/8.0/bin/java.exe" -cp "%AGENT_CP%" com.ibm.sklm.agent.SKLMTakeoverHADR %IP_HOSTNAME% %PORT% >> sklmTakeoverHADR.log 2>&1
) else (
	"%JAVA_HOME%/bin/java.exe" -cp "%AGENT_CP%" com.ibm.sklm.agent.SKLMTakeoverHADR %IP_HOSTNAME% %PORT% >> sklmTakeoverHADR.log 2>&1
)
set rc=%ERRORLEVEL%
if NOT %rc%==0 (
	echo  HADR Takeover failed.
)
if %rc%==0 (
	echo HADR Takeover successful.
)
goto end

:AGENT_CLASSPATH
for %%i in ("%WAS_HOME%\profiles\KLMProfile\installedApps\SKLMCell\sklm_kms.ear\*.jar") do call :SETCP %%i
for %%i in ("%WAS_HOME%\profiles\KLMProfile\installedApps\SKLMCell\sklm_kms.ear\lib\*.jar") do call :SETCP %%i
for %%i in ("%WAS_HOME%\lib\*.jar") do call :SETCP %%i


:SETCP
set AGENT_CP=%AGENT_CP%;%*


:end
exit /B %rc%