#!/bin/bash

CURR_DIR=`pwd`
CURR_DIR=${0%/*}
#echo "CURR_DIR=${CURR_DIR}"

export PATH=${PATH}:.

cd ${0%/*}

if [ ! -f agentStarter.properties ]
then
echo echo Cannot find agentStarter.properties. The Parameter values cannot be determined. Please enter appropriate inputs before running this script again.	  
echo WAS_HOME
echo SERVICE
echo PRIMARY_DB_NAME
echo PRIMARY_DB_USERNAME
echo PRIMARY_DB_PASSWORD
echo PRIMARY_DB_IP
echo PRIMARY_DB_PORT

exit 1
fi

. ./agentStarter.properties
ARGS_COUNT=$#
if [ ${ARGS_COUNT} -lt 1 -o ${ARGS_COUNT} -eq 2 -o ${ARGS_COUNT} -gt 3 ];
then
echo Usage: 
echo		sklmTakeoverHADR.sh "<Path to WAS_HOME>" [IP_HOSTNAME] [AGENT_PORT]
echo		where
echo		the Input Parameter is the path to WAS_HOME.
echo Example: 
echo		sklmTakeoverHADR.sh "C:\Program Files\IBM\WebSphere\AppServer"
echo 		OR
echo		sklmTakeoverHADR.sh "C:\Program Files\IBM\WebSphere\AppServer" host1 60015
echo Note:	Please ensure the WAS HOME path is correct.
exit 1
fi

export WAS_HOME=$1
IP_HOSTNAME=$2
PORT=$3

if [ ! -d ${WAS_HOME} ]
then
echo "WAS_HOME Path Invalid"
exit 1
fi

if [ !  ${JAVA_HOME} ]
then
export JAVA_HOME=${WAS_HOME}/java/8.0
fi

if [ ! -d ${JAVA_HOME} ]
then
echo "JAVA_HOME ${JAVA_HOME} is not directory."
exit 1
fi


AGENT_CP=${CURR_DIR}/com.ibm.sklm.agent.jar:${WAS_HOME}/runtimes/com.ibm.ws.admin.client_9.0.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.obfuscation.jar:${WAS_HOME}/universalDriver/lib/db2jcc4.jar:${WAS_HOME}/universalDriver/lib/db2jcc_license_cu.jar:${WAS_HOME}/lib/j2ee.jar:${WAS_HOME}/plugins/com.ibm.icu.jar:${WAS_HOME}/plugins/com.ibm.tklm.commands.jar:${WAS_HOME}/java/jre/lib/ext/ibmkeycert.jar:${WAS_HOME}/java/jre/lib/ext/ibmpkcs11impl.jar:${WAS_HOME}/java/jre/lib/ext/ibmjcefips.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.passwordpolicy.jar

#echo "****** AGENT_CP ${AGENT_CP}*******"

shopt -s nullglob
for f in ${WAS_HOME}/plugins/*.jar
do
	AGENT_CP=${AGENT_CP}:$f
done
for f in ${WAS_HOME}/lib/*.jar
do
	AGENT_CP=${AGENT_CP}:$f
done
for f in ${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/*.jar
do
	AGENT_CP=${AGENT_CP}:$f
done
for f in ${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/lib/*.jar
do
    AGENT_CP=${AGENT_CP}:$f
done

${JAVA_HOME}/bin/java -cp ${AGENT_CP} com.ibm.sklm.agent.SKLMTakeoverHADR ${IP_HOSTNAME} ${PORT} > sklmTakeoverHADR.log 2>&1
rc=$?
if [ $rc -eq 0 ]; then
   	echo "HADR Takeover successful."
else
	echo "HADR Takeover failed."
fi

exit $rc
