@echo off

SETLOCAL
 
SET CURR_DIR=%~dp0

:: Keep Local Variables


SET SERVICE=
SET PRIMARY_DB_NAME=
SET PRIMARY_DB_USERNAME=
SET PRIMARY_DB_PASSWORD=
SET PRIMARY_DB_IP=
SET PRIMARY_DB_PORT=
SET STANDBY_DB_NAME=
SET STANDBY_DB_USERNAME=
SET STANDBY_DB_PASSWORD=
SET STANDBY_DB_IP=
SET STANDBY_DB_PORT=
SET SELF_KEYSTORE_PASSWORD=

cd %CURR_DIR%

if not exist agentStarter.properties goto noconfig

for /f "tokens=1,2,3 delims==" %%a in (agentStarter.properties) do (
	
	if "%%a"=="SERVICE" set SERVICE=%%b
	if "%%a"=="PRIMARY_DB_NAME" set PRIMARY_DB_NAME=%%b
	if "%%a"=="PRIMARY_DB_USERNAME" set PRIMARY_DB_USERNAME=%%b
	if "%%a"=="PRIMARY_DB_PASSWORD" set PRIMARY_DB_PASSWORD=%%b
	if "%%a"=="PRIMARY_DB_IP" set PRIMARY_DB_IP=%%b
	if "%%a"=="PRIMARY_DB_PORT" set PRIMARY_DB_PORT=%%b
	if "%%a"=="STANDBY_1_DB_NAME" set STANDBY_DB_NAME=%%b
	if "%%a"=="STANDBY_1_DB_USERNAME" set STANDBY_DB_USERNAME=%%b
	if "%%a"=="STANDBY_1_DB_PASSWORD" set STANDBY_DB_PASSWORD=%%b
	if "%%a"=="STANDBY_1_DB_IP" set STANDBY_DB_IP=%%b
	if "%%a"=="STANDBY_1_DB_PORT" set STANDBY_DB_PORT=%%b
	if "%%a"=="SELF_KEYSTORE_PASSWORD" set SELF_KEYSTORE_PASSWORD=%%b
)


if [%1]==[] (
echo Usage: 
echo		startAgent.bat "Path to WAS_HOME"
echo		where
echo		the Input Parameter is the path to WAS_HOME.
echo Example: 
echo		startAgent.bat "C:\Program Files\IBM\WebSphere\AppServer"
echo Note:	Please ensure the WAS HOME path is correct.			
goto end
)

SET WAS_HOME=%~1

echo %WAS_HOME%
::Validate WAS_HOME availability
if not exist "%WAS_HOME%" (
	echo.
	echo WAS_HOME Path not Valid.
	goto end
)

:: Validate all the Inputs
if "%SERVICE%"=="" (
	echo.
	echo Please enter the Service to Monitor.
	goto end
)

if "%PRIMARY_DB_NAME%"=="" (
	echo.
	echo PRIMARY_DB_NAME Property is empty.
	goto end
)

if "%PRIMARY_DB_USERNAME%"=="" (
	echo.
	echo PRIMARY_DB_USERNAME Property is empty.
	goto end
)

if "%PRIMARY_DB_PASSWORD%"=="" (
	echo.
	echo PRIMARY_DB_PASSWORD Property is empty.
	goto end
)

if "%PRIMARY_DB_IP%"=="" (
	echo.
	echo PRIMARY_DB_IP Property is empty.
	goto end
)

if "%PRIMARY_DB_PORT%"=="" (
	echo.
	echo PRIMARY_DB_PORT Property is empty.
	goto end
)																																							 

:: Check for Java Home
if not "%JAVA_HOME%"=="" (
	if not exist "%JAVA_HOME%\\bin\\java.exe" (
		echo.
		echo Invalid JAVA_HOME directory set.
		goto end	
	)
)

goto run

:noconfig	
@echo Cannot find agentStarter.properties. The Parameter values cannot be determined. Please enter appropriate inputs before running this script again.	  
@WAS_HOME
@SERVICE
@PRIMARY_DB_NAME
@PRIMARY_DB_USERNAME
@PRIMARY_DB_PASSWORD
@PRIMARY_DB_IP
@PRIMARY_DB_PORT	
goto end		 

:run
echo.
SET AGENT_CP=%CURR_DIR%com.ibm.sklm.agent.jar;%WAS_HOME%/runtimes/com.ibm.ws.admin.client_9.0.jar;%WAS_HOME%/lib/ext/com.ibm.tklm.obfuscation.jar;%WAS_HOME%/plugins/com.ibm.ws.runtime.jar;%WAS_HOME%/universalDriver/lib/db2jcc4.jar;%WAS_HOME%/universalDriver/lib/db2jcc_license_cu.jar;%WAS_HOME%/lib/j2ee.jar;%WAS_HOME%/plugins/com.ibm.icu.jar;%WAS_HOME%/plugins/com.ibm.tklm.commands.jar;%WAS_HOME%/java/jre/lib/ext/ibmkeycert.jar;%WAS_HOME%/java/jre/lib/ext/ibmpkcs11impl.jar;%WAS_HOME%/java/jre/lib/ext/ibmjcefips.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.jar;%WAS_HOME%/plugins/org.eclipse.emf.common.jar;%WAS_HOME%/plugins/org.eclipse.emf.commonj.sdo.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.sdo.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.xmi.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.change.jar;%WAS_HOME%/runtimes/com.ibm.jaxws.thinclient_9.0.jar;%WAS_HOME%/plugins/com.ibm.ws.runtime.wim.base.jar;%WAS_HOME%/lib/ext/com.ibm.tklm.passwordpolicy.jar;%WAS_HOME%/plugins/org.apache.tuscany.sdo.sca.core.model/JSON4J.jar;
rem echo %AGENT_CP%
call :AGENT_CLASSPATH

"%WAS_HOME%/java/8.0/bin/java.exe" -cp "%AGENT_CP%" com.ibm.sklm.agent.launcher.SKLMAgentLauncher "%WAS_HOME%" > agentStarter.log 2>&1

set rc=%ERRORLEVEL%
if NOT %rc%==0 (
	echo  Agent Could not be Initialized.
)
if %rc%==0 (
	echo Agent Initialized.
)
goto end

:AGENT_CLASSPATH
for %%i in ("%WAS_HOME%\profiles\KLMProfile\installedApps\SKLMCell\sklm_kms.ear\*.jar") do call :SETCP %%i
for %%i in ("%WAS_HOME%\profiles\KLMProfile\installedApps\SKLMCell\sklm_kms.ear\lib\*.jar") do call :SETCP %%i
for %%i in ("%WAS_HOME%\lib\*.jar") do call :SETCP %%i


:SETCP
set AGENT_CP=%AGENT_CP%;%*


:end
exit /B 0