#!/bin/bash
SCRIPTDIR=`dirname $0`
CURDIR=`pwd`
USRID=`id -u`
GID=`id -g`
cd $SCRIPTDIR
SCRIPTDIR=`pwd`
cd $CURDIR
#echo $USRID

export PATH=${PATH}:.

cd ${0%/*}

if [ ! -f ${SCRIPTDIR}/agentStarter.properties ]
then
echo echo Cannot find agentStarter.properties. The Parameter values cannot be determined. Please enter appropriate inputs before running this script again.	  
echo WAS_HOME
echo SERVICE
echo PRIMARY_DB_NAME
echo PRIMARY_DB_USERNAME
echo PRIMARY_DB_PASSWORD
echo PRIMARY_DB_IP
echo PRIMARY_DB_PORT

exit 1
fi

. ${SCRIPTDIR}/agentStarter.properties

if [ ! $1 ]
then
echo Usage: 
echo		stopAgent.sh "<Path to WAS_HOME>"
echo		where
echo		the Input Parameter is the path to WAS_HOME.
echo Example: 
echo		stopAgent.sh "/opt/IBM/WebSphere/AppServer"
echo Note:	Please ensure the WAS HOME path is correct.
exit 1
fi

export WAS_HOME=$1

if [ ! -d ${WAS_HOME} ]
then
	echo "WAS_HOME Path Invalid"
	exit 1
else
	export JAVA_HOME=${WAS_HOME}/java/8.0
fi

if [ ! -d ${JAVA_HOME} ]
then
echo "JAVA_HOME ${JAVA_HOME} is not directory."
exit 1
fi

if [ -z ${SERVICE} ]
then 
echo "SERVICE Property is empty"
exit 1
fi

if [ -z ${PRIMARY_DB_NAME} ]
then 
echo "PRIMARY_DB_NAME Property is empty"
exit 1
fi

if [ -z ${PRIMARY_DB_USERNAME} ]
then 
echo "PRIMARY_DB_USERNAME Property is empty"
exit 1
fi

if [ -z ${PRIMARY_DB_PASSWORD} ]
then 
echo "PRIMARY_DB_PASSWORD Property is empty"
exit 1
fi

if [ -z ${PRIMARY_DB_IP} ]
then 
echo "PRIMARY_DB_IP Property is empty"
exit 1
fi

if [ -z ${PRIMARY_DB_PORT} ]
then 
echo "PRIMARY_DB_PORT Property is empty"
exit 1
fi


AGENT_CP=${SCRIPTDIR}/com.ibm.sklm.agent.jar:${WAS_HOME}/runtimes/com.ibm.ws.admin.client_9.0.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.obfuscation.jar:${WAS_HOME}/universalDriver/lib/db2jcc4.jar:${WAS_HOME}/universalDriver/lib/db2jcc_license_cu.jar:${WAS_HOME}/lib/j2ee.jar:${WAS_HOME}/plugins/com.ibm.icu.jar:${WAS_HOME}/plugins/com.ibm.tklm.commands.jar:${WAS_HOME}/java/jre/lib/ext/ibmkeycert.jar:${WAS_HOME}/java/jre/lib/ext/ibmpkcs11impl.jar:${WAS_HOME}/java/jre/lib/ext/ibmjcefips.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.passwordpolicy.jar

#echo "****** AGENT_CP ${AGENT_CP}*******"

shopt -s nullglob
for f in ${WAS_HOME}/plugins/*.jar
do
	AGENT_CP=${AGENT_CP}:$f
done
for f in ${WAS_HOME}/lib/*.jar
do
	AGENT_CP=${AGENT_CP}:$f
done
for f in ${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/*.jar
do
	AGENT_CP=${AGENT_CP}:$f
done
for f in ${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/lib/*.jar
do
    AGENT_CP=${AGENT_CP}:$f
done
${JAVA_HOME}/bin/java -cp ${AGENT_CP} com.ibm.sklm.agent.SKLMStopAgent ${WAS_HOME} > stopAgent.log 2>&1
rc=$?

if [ $GID -eq 0  ]; then
    chown ${PRIMARY_DB_USERNAME} ${SCRIPTDIR}/*.log
    chown ${PRIMARY_DB_USERNAME} $WAS_HOME/products/sklm/logs/*.*
fi

if [ $rc -eq 0 ]; then
   	echo "Agent Stopped"
else
	echo "Agent Could not be Stopped."
fi

exit 0










