#!/bin/bash

db2instancehome=$1
washome=$2
sklmhome=$3
db2username=$4
db2instance=$5
db2home=$6
useExistingDB2=$7

printUsage() {
	echo sklmPermissions.sh [DB2_INSTANCE_HOME] [WAS_HOME] [SKLM_HOME] [DB2_USER_NAME] [DB2_INSTANCE_NAME] [DB2_HOME] [USE_EXISTING_DB2]
	echo Example : sklmPermissions.sh /home/sklmdb30 /opt/IBM/WebSphere/AppServer /opt/IBM/SKLMV30 sklmdb30 sklmdb30Inst /opt/IBM/DB2SKLMV30 false
	echo  DB2_INSTANCE_HOME = /home/sklmdb30
	echo  WAS_HOME = /opt/IBM/WebSphere/AppServer
	echo  SKLM_HOME =/opt/IBM/SKLMV30
	echo  DB2_USER_NAME = sklmdb30
	echo  DB2_INSTACE_NAME = sklmdb30Inst
	echo  DB2_HOME =/opt/IBM/DB2SKLMV30
	echo  USE_EXISTING_DB2=false
}

echo call from config

SCRIPTHOME=${PWD}
TKLMTEMP=${HOME}/sklm41properties

if [[ -f ${TKLMTEMP}/db2unix.srcit ]]; then
        . ${TKLMTEMP}/"db2unix.srcit"
fi

if [ "$#" -lt "5" ]; then
	echo Invalid number of arguments.
	printUsage
	exit 1
fi

if [ "${db2username}" == "" ]; then
	echo DB2 User name value is invalid.
	exit 1
fi

if [ "${useExistingDB2}" == "" ]; then
        useExistingDB2=false
fi

if [ "${db2instance}" == "" ]; then
        echo DB2 Instance name value is invalid.
        exit 1
fi

if [ "${db2home}" == "" ]; then
	db2home=$DB2INSTALLDIR        
fi

if [ ! -d ${db2home} ]; then
	echo Directory "${db2home}" does not exist.
	exit 1
else
	if [[ $EUID -eq 0 ]]; then
		if [ ! -d ${db2home}/adm ]; then
			echo Invalid DB2_HOME value set.
			exit 1
		fi
	fi
fi

if [ ! -d ${db2instancehome} ]; then
	echo Directory "${db2instancehome}" does not exist.
	exit 1
else
	if [ ! -d ${db2instancehome}/sqllib ]; then
		echo Invalid DB2_INSTANCE_HOME value set.
		exit 1
	fi	
fi

if [ ! -d ${washome} ]; then
	echo Directory "${washome}" does not exist.
	exit 1
else
	if [ ! -d ${washome}/profiles ]; then
		echo Invalid WAS_HOME value set.
		exit 1
	fi
fi

if [ ! -d ${sklmhome} ]; then
	echo Directory "${sklmhome}" does not exist.
	exit 1
else
	if [ ! -d ${sklmhome}/bin/LDAPIntegration ]; then
		echo Invalid SKLM_HOME value set.
		exit 1
	fi	
fi

#For install with existing db2
echo useExistingDB2=${useExistingDB2}
if [[ "${useExistingDB2}"  == "false" ]]; then
	echo setting permissions for DB2_HOME
	chown -R ${db2username} ${db2home}
	chmod -R 750 ${db2home}
	echo setting permissions for DB2_HOME - DONE
fi

echo setting permissions for DB2_INSTANCE_HOME
if [[ $EUID -eq 0 ]]; then
	chmod -R 750 ${db2instancehome}
	chmod 4555 ${db2instancehome}/sqllib/security/db2chpw
	chmod 4555 ${db2instancehome}/sqllib/security/db2ckpw
else
	chmod -R 750 ${db2instancehome}/sqllib/
	chmod -R 750 ${db2instancehome}/sklmdbarchive/
	chmod -R 750 ${db2instancehome}/${db2instance}
fi
echo setting permissions for DB2_INSTANCE_HOME - DONE

echo setting permissions for SKLM_HOME
chmod -R 700 ${db2instancehome}/sklm41properties
chmod -R 700 ${sklmhome}
echo setting permissions for SKLM_HOME - DONE

echo setting permissions for WAS_HOME
chmod -R 700 ${washome}
chmod -R 700 ${washome}/products/sklm/data
echo setting permissions for WAS_HOME - DONE

exit 0
