import string, sys
import config

id_name="myldap"
LDAP_server_type=config.LDAP_server_type
login_id=config.login_id
ip=config.ip
port=config.port
gr_name=config.gr_name
pr_name=config.pr_name
gr_obj_class=config.gr_obj_class
pr_obj_class=config.pr_obj_class
mem_name=config.mem_name
mem_obj_class=config.mem_obj_class
base_entry=config.base_entry
scope=config.scope

##Configure Federated Repository

try:
    params = "[-id " + id_name + " -ldapServerType " + LDAP_server_type + " -loginProperties " + login_id + "]"
    result = AdminTask.createIdMgrLDAPRepository(params)
    print result
    print "Created LDAP Repository.."
except:
    print "Exception creating LDAP repository myldap - " + result
    sys.exit(101)
	
try:			
   params = "[-id " + id_name + " -host " + ip + " -port "+ port + "]"
   result = AdminTask.addIdMgrLDAPServer(params)
   print result
   print "Added LDAP Server host.."
except:
   print "Exception Adding LDAP Server host - " +result
   sys.exit(101)

try:
   params = "[-id " + id_name + " -name " + base_entry + " -nameInRepository " + base_entry + "]"
   result = AdminTask.addIdMgrRepositoryBaseEntry(params)
   print result
   print "Added Repository Base Entry.."
except:
   print "Exception updating repository - " +result
   sys.exit(101)

try:
   params = "[-name defaultWIMFileBasedRealm -baseEntry " + base_entry + "]"
   result = AdminTask.addIdMgrRealmBaseEntry(params)
   print result
   print "Added base entry.."
except:
   print "Exception Adding base entry - " +result
   sys.exit(101)


try:
   params = "[-id " + id_name + " -name Group]"
   result = AdminTask.deleteIdMgrLDAPEntityType (params)
   print result
   print "Deleted LDAP Entity Type Group.."
except:
   print "Exception Deleting LDAP Entity type - " + result
   sys.exit(101)

try:
   params = "[-id " + id_name + " -name " + gr_name + " -objectClasses " + gr_obj_class + "]"
   result = AdminTask.addIdMgrLDAPEntityType (params)
   print result
   print "Added LDAP Entity Type Group.."
except:
   print "Exception adding LDAP entity type - " + result
   sys.exit(101)
	
try:
   params = "[-id " + id_name + " -name PersonAccount]"
   result = AdminTask.deleteIdMgrLDAPEntityType (params)
   print result
   print "Deleted LDAP Entity Type PersonAccount.."
except:
   print "Exception Deleting LDAP Entity type - " + result
   sys.exit(101)

try:	
   params = "[-id " + id_name + " -name " + pr_name + " -objectClasses " + pr_obj_class + "]"
   result = AdminTask.addIdMgrLDAPEntityType (params)
   print result
   print "Added LDAP Entity Type PersonAccount.."
except:
   print "Exception adding LDAP entity type - " + result
   sys.exit(101)

try:
   params = "[-id " + id_name + " -name member]"
   result = AdminTask.deleteIdMgrLDAPGroupMemberAttr (params)
   print result
   print "Deleted Group Member Attribute.."
except:
   print "Exception Deleting group member attribute - " + result
   sys.exit(101)

try:
   params = "[-id " + id_name + " -name " + mem_name + " -scope " + scope + " -objectClass " + mem_obj_class + "]"
   print params
   result = AdminTask.addIdMgrLDAPGroupMemberAttr (params)
   print result
   print "Added Group Member Attribute.."
except:
   print "Exception adding group member attribute -" + result
   sys.exit(101) 
   
try:
    print "Saving config"
    result = AdminConfig.save()
except:
    print "Exception saving config - " + result
    sys.exit(101)
