#
#####################################################################
## This script will change the web security setting in security.xml
## name="com.ibm.wsspi.security.web.webAuthReq"
## value="persisting"
#####################################################################
#

import sys
def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef

secid = AdminConfig.list("Security" )

webAAIDList = AdminConfig.showAttribute(secid, "webAuthAttrs" )

webAAID = wsadminToList(webAAIDList)

webAAIDFirst = webAAID[0]

AdminConfig.showall(webAAIDFirst )

valuelist = ["value", "persisting"]

attr = [valuelist]

AdminConfig.modify(webAAIDFirst, attr )

AdminConfig.save( )


#------------------------------------------------------------------------------
# Main entry point - Update 
#					1) the server.xml for setting the secure cookie and 
#					2) security.xml for setting the requireSSL flag
#					3) security.xml for the list of ciphers to ignore _RSA_WITH_3DES_EDE_CBC_SHA , _RSA_EXPORT_  and  _DES_ 			
#------------------------------------------------------------------------------

print ("Updating the server.xml for setting the secure cookie")
server1 = AdminConfig.getid('/Server:server1')
print ("server1=" + server1)
comp = AdminConfig.list('ApplicationServer', server1)
print ("comp=" + comp)
webcomp = AdminConfig.list('WebContainer', comp)
print ("webcomp=" + webcomp)
services = AdminConfig.showAttribute(webcomp,'services')
print ("services=" + services)
sessServices = services[1:len(services)-1] 	
COOK = AdminConfig.showAttribute(sessServices,'defaultCookieSettings')
print ("defaultCookieSettings=" + COOK)
kuki = ['secure', "true"]
cookie = [kuki]
AdminConfig.modify(COOK, cookie)
AdminConfig.save()	
print("Updated the server.xml which has secure cookie")

print ("Updating the security.xml for setting the requireSSL flag")
AdminTask.configureSingleSignon(['-enable', 'true', '-requiresSSL', 'true'])
AdminConfig.save()
print("Updated security.xml for setting the requireSSL flag")
print ("Updating security.xml for the list of ciphers to ignore _RSA_WITH_3DES_EDE_CBC_SHA , _RSA_EXPORT_  and  _DES_")
print ("Get the list of ciphers")
ciphers = AdminTask.listSSLCiphers('[-sslConfigAliasName NodeDefaultSSLSettings  -securityLevel CUSTOM]');
print ("list of ciphers=" + ciphers);
cipherslist = ciphers.split('\n')
enabledciphers = '';
for item in cipherslist:
	print ("c=" + item);
	item = item.rstrip();         #removes any Windows "\r"
	if (len(item)>0):
		if not(item.find('_RSA_WITH_3DES_EDE_CBC_SHA') > 0 or item.find('_RSA_EXPORT_') > 0 or item.find('_RC4_') > 0 or item.find('_DES_') > 0):
			if (enabledciphers == ''):
				enabledciphers = item
			else:
				enabledciphers = enabledciphers + ' ' + item
#endfor
AdminTask.modifySSLConfig('[-alias NodeDefaultSSLSettings -securityLevel CUSTOM -enabledCiphers "' + enabledciphers +'" ]');
print ("enabledciphers=" + enabledciphers);
AdminConfig.save()
print("Updated security.xml for the list of ciphers")
