import sys

SUCCESS = "SUCCESS"
FAILURE = "FAILURE"

######### CREATE USER TO ACCESS KERBEROS SERVICE ######

def create_kerberos_user(userId, usrPassword):
    global AdminConfig
    
    print "--> proc create kerberos user"
    print "--> userId is" + userId
    
    security = AdminConfig.getid('/Cell:SKLMCell/Security:/')
    alias = ['alias', 'krbUser']
    userid = ['userId', userId]
    password = ['password', usrPassword]
    jaasAttrs = [alias, userid, password]
    AdminConfig.create('JAASAuthData', security, jaasAttrs)
    return SUCCESS
    
#endDef
    

######### Update SKLM data source #########

def update_sklm_datasource (dataSourceID, serviceName):
    global AdminConfig

    print "--> proc update_sklm_datasource"
    print "--> SKLM dataSourceId is " + dataSourceID

    if (dataSourceID != ""):  
        AdminConfig.modify(dataSourceID, '[[authDataAlias "krbUser"]]')  
        propSet = AdminConfig.showAttribute( dataSourceID, 'propertySet')
        attrs = [["name", "kerberosServerPrincipal"], ["type", "java.lang.String"], ["value", serviceName]]
        AdminConfig.create("J2EEResourceProperty", propSet, attrs)
        attrs = [["name", "securityMechanism"], ["type", "java.lang.Short"], ["value", "11"]]
        AdminConfig.create("J2EEResourceProperty", propSet, attrs)
        mapping = AdminConfig.showAttribute( dataSourceID, 'mapping')
        AdminConfig.modify(mapping, '[[mappingConfigAlias "DefaultPrincipalMapping"]]')
        AdminConfig.modify(mapping, '[[authDataAlias "krbUser"]]')
        
        return SUCCESS
    else:
        return FAILURE
    #endElse
#endDef

def update_timer_Service (id):
       print "--> proc update_timer_Service dataSource Alias"
       print "Timer service id " + id
       AdminConfig.modify(id, '[[datasourceAlias "krbUser"]]') 
       return "SUCCESS"

#endDef


#####################################################
#                                                   #
#               SCRIPT STARTS HERE                  #
#                                                   #
#        Configure Datasource with Kerberos         #
#                                                   #
#####################################################


if (len(sys.argv) <> 5):
    print "  "
    print "Incorrect number of args.  "
    print "   arg1 - Kerberos Db2 Service name"
    print "   arg2 - UserId to access the Db2 kerberos service"
    print "   arg3 - Password to access the Db2 kerberos service"
    print "   arg4 - Path of the kerberos config file"
    print "   arg5 - Path of the Jaas config file"
    exit
#endIf

db2ServiceName = sys.argv[0]
userId = sys.argv[1]
usrPassword = sys.argv[2]
krbConfPath = sys.argv[3]
jaasConfPath = sys.argv[4]

print "\"Kerberos Db2 Service Name\" : " + db2ServiceName
print "\"UserId to access Kerberos Service\" : " + userId 

#CREATE KERBEROS USER
returnCode = create_kerberos_user(userId, usrPassword)
if (returnCode == SUCCESS):
        AdminConfig.save( )
#endIf

#UPDATE SKLM DataSource
dataSourceId = AdminConfig.list('DataSource', 'SKLM DataSource*')
returnCode = update_sklm_datasource(dataSourceId, db2ServiceName)

print "Debug --> return from update_sklm_datasource SKLM DataSource : " + returnCode
if (returnCode == SUCCESS):
        AdminConfig.save( )
#endIf

#UPDATE SKLM scheduler XA Datasource
dataSourceId = AdminConfig.list('DataSource', 'SKLM scheduler XA Datasource*')
returnCode = update_sklm_datasource(dataSourceId, db2ServiceName)

print "Debug --> return from update_sklm_datasource SKLM scheduler XA Datasource  : " + returnCode
if (returnCode == SUCCESS):
        AdminConfig.save( )
#endIf

#UPDATE SKLM scheduler ALT XA Datasource
dataSourceId = AdminConfig.list('DataSource', 'SKLM Alternate XA Datasource*')
returnCode = update_sklm_datasource(dataSourceId, db2ServiceName)

print "Debug --> return from update_sklm_datasource SKLM Alternate XA Datasource  : " + returnCode
if (returnCode == SUCCESS):
        AdminConfig.save( )
#endIf

#UPDATE WIM Datasource
dataSourceId = AdminConfig.list('DataSource', 'WIM Data Source*')
returnCode = update_sklm_datasource(dataSourceId, db2ServiceName)

print "Debug --> return from update_sklm_datasource WIM Datasource  : " + returnCode
if (returnCode == SUCCESS):
        AdminConfig.save( )
#endIf

#UPDATE EJB_TIMER_SERVICE USER
ejbTimerId=AdminConfig.list("EJBTimer")
returnCode = update_timer_Service(ejbTimerId)

print "Debug --> return from update_timer_Service EJB TIMER SERVICE  : " + returnCode
if (returnCode == SUCCESS):
        AdminConfig.save( )
#endIf

#UPDATE JVM PARAMETERS
existingJVMProperties = AdminTask.showJVMProperties('[-serverName server1 -nodeName SKLMNode -propertyName genericJvmArguments]');
updatedJVMProperties = existingJVMProperties + " -Djava.security.krb5.conf=" + krbConfPath + " -Djava.security.auth.login.config="  + jaasConfPath
print updatedJVMProperties
AdminTask.setGenericJVMArguments('[-serverName server1 -nodeName SKLMNode -genericJvmArguments "' + updatedJVMProperties +'"]');
AdminConfig.save();
