@echo OFF

rem #############################################################################
rem #
rem #
rem # File Name: db2RemoveKerberos.bat
rem # ===========================================================================
rem # Licensed Materials - Property of IBM
rem #
rem # 5724-T60 5608-A91
rem # (C) Copyright IBM Corp. 2021 All Rights Reserved
rem #
rem # US Government Users Restricted Rights - Use, duplication, or
rem # disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
rem #  ===========================================================================
rem # This script will remove Db2 configuration to use Kerberos Authentication
rem # 
rem #############################################################################

:: Keep variables local
SETLOCAL ENABLEDELAYEDEXPANSION
SET CUR_DIR=%~dp0


call :configureDb2
set rc=%ERRORLEVEL%
if NOT %rc%==0 (
    echo  Db2 remove Kerberos Authentication failed.
)
if %rc%==0 (
    echo DB2 remove Kerberos Authentication completed.
)
goto end


:configureDb2

    db2 update dbm cfg using AUTHENTICATION SERVER
    db2 update dbm cfg using CLNT_KRB_PLUGIN NULL 
    db2 update dbm cfg using SRVCON_GSSPLUGIN_LIST NULL
    goto :EOF
    


:usage
    echo *************************************************************
    echo Usage:     
    echo db2RemoveKerberos.bat 
    echo *************************************************************
    goto end

:end
exit /B 0