import sys

SUCCESS = "SUCCESS"
FAILURE = "FAILURE"

def _splitlines(s):
  rv = [s]
  if '\r' in s:
    rv = s.split('\r\n')
  elif '\n' in s:
    rv = s.split('\n')
  if rv[-1] == '':
    rv = rv[:-1]
  return rv
  
def getJVMProperties(s):
    finalJVMProperties = ""
    strarr = s.strip().split(" ")
    for str in strarr:
        if(str != " " and "-Djava.security.krb5.conf" not in str and "-Djava.security.auth.login.config" not in str):
            finalJVMProperties = finalJVMProperties + " " + str

    return finalJVMProperties
    

######### DELETE KERBEROS USER ######

def delete_kerberos_user():
    global AdminConfig

    print "--> proc delete kerberos user"
    print "--> alias is krbUser"

    jaasEntries = AdminConfig.list('JAASAuthData')
    for jaasEntry in jaasEntries.splitlines():
        if (AdminConfig.showAttribute(jaasEntry, "alias") == 'krbUser'):
            AdminConfig.remove(jaasEntry)
            break
        else:
            continue
    return SUCCESS


# endDef


######### Update SKLM data source #########

def update_sklm_datasource(dataSourceID):
    global AdminConfig
    
    print "--> proc update_sklm_datasource"
    print "--> SKLM dataSourceId is " + dataSourceID

    if (dataSourceID != ""):
        AdminConfig.modify(dataSourceID, '[[authDataAlias "sklm_db"]]')
        propset = AdminConfig.list("J2EEResourcePropertySet", dataSourceID )
        properties = AdminConfig.list("J2EEResourceProperty", propset)
        for psItem in _splitlines(properties):
            if ("kerberosServerPrincipal".lower() == AdminConfig.showAttribute(psItem, "name").lower() or "securityMechanism".lower() == AdminConfig.showAttribute(psItem, "name").lower() ):
                print "--> Removing kerberos related property" 
                AdminConfig.remove(psItem)
        mapping = AdminConfig.showAttribute( dataSourceID, 'mapping')
        AdminConfig.modify(mapping, '[[mappingConfigAlias ""]]')
        AdminConfig.modify(mapping, '[[authDataAlias "sklm_db"]]')
        return SUCCESS
    else:
        return FAILURE
    # endElse
# endDef

def update_timer_Service (id):
       print "--> proc update_timer_Service dataSource Alias"
       print "Timer service id " + id
       AdminConfig.modify(id, '[[datasourceAlias "sklm_db"]]') 
       return "SUCCESS"

#endDef


#####################################################
#                                                   #
#               SCRIPT STARTS HERE                  #
#                                                   #
#        Remove Kerberos Configuration DataSource   #
#                                                   #
#####################################################


# UPDATE SKLM DataSource
dataSourceId = AdminConfig.list('DataSource', 'SKLM DataSource*')
returnCode = update_sklm_datasource(dataSourceId)

print "Debug --> return from update_sklm_datasource SKLM DataSource : " + returnCode
if (returnCode == SUCCESS):
    AdminConfig.save()
# endIf

# UPDATE SKLM scheduler XA Datasource
dataSourceId = AdminConfig.list('DataSource', 'SKLM scheduler XA Datasource*')
returnCode = update_sklm_datasource(dataSourceId)

print "Debug --> return from update_sklm_datasource SKLM scheduler XA Datasource  : " + returnCode
if (returnCode == SUCCESS):
    AdminConfig.save()
# endIf

#UPDATE SKLM scheduler ALT XA Datasource
dataSourceId = AdminConfig.list('DataSource', 'SKLM Alternate XA Datasource*')
returnCode = update_sklm_datasource(dataSourceId)

print "Debug --> return from update_sklm_datasource SKLM Alternate XA Datasource  : " + returnCode
if (returnCode == SUCCESS):
        AdminConfig.save( )
#endIf

#UPDATE WIM Data Source
dataSourceId = AdminConfig.list('DataSource', 'WIM Data Source*')
returnCode = update_sklm_datasource(dataSourceId)

print "Debug --> return from update_sklm_datasource WIM Data Source Datasource  : " + returnCode
if (returnCode == SUCCESS):
        AdminConfig.save( )
#endIf

#UPDATE EJB_TIMER_SERVICE USER
ejbTimerId=AdminConfig.list("EJBTimer")
returnCode = update_timer_Service(ejbTimerId)

print "Debug --> return from update_timer_Service EJB TIMER SERVICE  : " + returnCode
if (returnCode == SUCCESS):
        AdminConfig.save( )
#endIf

# REMOVE KERBEROS USER
returnCode = delete_kerberos_user()
if (returnCode == SUCCESS):
    AdminConfig.save()
# endIf

#UPDATE JVM PARAMETERS
existingJVMProperties = AdminTask.showJVMProperties('[-serverName server1 -nodeName SKLMNode -propertyName genericJvmArguments]');
updatedJVMProperties = getJVMProperties(existingJVMProperties)
print updatedJVMProperties
AdminTask.setGenericJVMArguments('[-serverName server1 -nodeName SKLMNode -genericJvmArguments "' + updatedJVMProperties +'"]');
AdminConfig.save();