#!/bin/sh
echo $0
cd `dirname $0`
SCRIPTDIR=`pwd`

echo $SCRIPTDIR

if [ ! -f cluster.properties ]
then
echo "cluster.properties file not found."
exit 1
fi

. ./cluster.properties


if [ ! -d ${JAVA_HOME} ]
then
echo "JAVA_HOME variable not set."
exit 1
fi

echo "JAVA_HOME=$JAVA_HOME"


if [ -z ${WAS_HOME} ]
then 
echo "WAS_HOME Property is empty"
exit 1
fi

echo "WAS_HOME=$WAS_HOME"
export WAS_HOME=$WAS_HOME

if [ -z ${SKLM_INSTALL_PATH} ]
then 
echo "SKLM_INSTALL_PATH Property is empty"
exit 1
fi


if [ -z ${IM_INSTALL_DIR} ]
then 
echo "IM_INSTALL_DIR Property is empty"
exit 1
fi

#Sample file content
#JAVA_HOME=/opt/IBM/WebSphere/AppServer/java/8.0
#SKLM_INSTALL_PATH=/opt/IBM/SKLMV41
#WAS_HOME=/opt/IBM/WebSphere/AppServer
#IM_INSTALL_DIR=/opt/IBM/InstallationManager/eclipse


MIG_CP=${SKLM_INSTALL_PATH}/migration/com.ibm.sklm.migration.jar:${WAS_HOME}/universalDriver/lib/db2jcc4.jar:${WAS_HOME}/lib/j2ee.jar:${WAS_HOME}/plugins/com.ibm.icu.jar:${WAS_HOME}/plugins/com.ibm.tklm.commands.jar:${WAS_HOME}/java/8.0/jre/lib/ext/ibmkeycert.jar:${WAS_HOME}/java/8.0/jre/lib/ext/ibmpkcs11impl.jar:${WAS_HOME}/java/8.0/jre/lib/ext/ibmjcefips.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.obfuscation.jar;

#echo "Migration ...echo ${MIG_CP}"

shopt -s nullglob
for f in ${WAS_HOME}/plugins/*.jar
do
	MIG_CP=${MIG_CP}:$f
done
for f in ${WAS_HOME}/lib/*.jar
do
	MIG_CP=${MIG_CP}:$f
done
for f in ${IM_INSTALL_DIR}/plugins/com.ibm.cic.common.core_*.jar
do
	MIG_CP=${MIG_CP}:$f
done
for f in ${IM_INSTALL_DIR}/plugins/org.eclipse.core.runtime_*.jar
do
	MIG_CP=${MIG_CP}:$f
done
for f in ${IM_INSTALL_DIR}/plugins/org.eclipse.osgi*.jar
do
	MIG_CP=${MIG_CP}:$f
done
for f in ${IM_INSTALL_DIR}/plugins/org.apache.commons*.jar
do
	MIG_CP=${MIG_CP}:$f
done
for f in ${IM_INSTALL_DIR}/plugins/org.eclipse.equinox.common*.jar
do
	MIG_CP=${MIG_CP}:$f
done
for f in ${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/lib/*.jar
do
    MIG_CP=${MIG_CP}:$f
done

#echo $MIG_CP

#echo ${JAVA_HOME}/bin/java -cp ${MIG_CP} com.ibm.sklm.data.mig.cluster.ClusterMain 
${JAVA_HOME}/bin/java -cp ${MIG_CP} com.ibm.sklm.data.mig.cluster.ClusterMain 

exit 0
