#!/bin/sh

if [ ! -f ./migration.properties ]
then
echo "migration.properties file not found."
exit 1
fi

. ./migration.properties

if [ ! -d ${JAVA_HOME} ]
then
echo "JAVA_HOME variable not set."
exit 1
fi

if [ -z ${WAS_HOME} ]
then 
echo "WAS_HOME Property is empty"
exit 1
fi
if [ -z ${TKLM_TIP_HOME} ]
then 
echo "TKLM_TIP_HOME Property is empty"
exit 1
fi
if [ -z ${WAS_ADMIN_ID} ]
then 
echo "WAS_ADMIN_ID Property is empty"
exit 1
fi
if [ -z ${WAS_ADMIN_PASSWORD} ]
then 
echo "WAS_ADMIN_PASSWORD Property is empty"
exit 1
fi
if [ -z ${SKLM_INSTALL_PATH} ]
then 
echo "SKLM_INSTALL_PATH Property is empty"
exit 1
fi
if [ -z ${SKLM_ADMIN_USER} ]
then 
echo "SKLM_ADMIN_USER Property is empty"
exit 1
fi
if [ -z ${SKLM_ADMIN_USER_PASSWORD} ]
then 
echo "SKLM_ADMIN_USER_PASSWORD Property is empty"
exit 1
fi
if [ -z ${MIG_LOG_PATH} ]
then 
echo "MIG_LOG_PATH Property is empty"
exit 1
fi
if [ -z ${TKLM_VERSION} ]
then 
echo "TKLM_VERSION Property is empty"
exit 1
fi
if [ -z ${TKLM_DB_PWD} ]
then 
echo "TKLM_DB_PWD Property is empty"
exit 1
fi
if [ -z ${IM_INSTALL_DIR} ]
then 
echo "IM_INSTALL_DIR Property is empty"
exit 1
fi

echo WAS_HOME=${WAS_HOME} > ${SKLM_INSTALL_PATH}/migration/bin/cluster.properties
echo JAVA_HOME=${WAS_HOME}/java/8.0 >> ${SKLM_INSTALL_PATH}/migration/bin/cluster.properties
echo SKLM_INSTALL_PATH=${SKLM_INSTALL_PATH} >> ${SKLM_INSTALL_PATH}/migration/bin/cluster.properties
echo IM_INSTALL_DIR=${IM_INSTALL_DIR} >> ${SKLM_INSTALL_PATH}/migration/bin/cluster.properties

${WAS_HOME}/bin/wsadmin.sh -lang jython -profileName KLMProfile -username ${WAS_ADMIN_ID} -password ${WAS_ADMIN_PASSWORD} -f ${SKLM_INSTALL_PATH}/migration/bin/migrateUsers.py ${TKLM_TIP_HOME} ${WAS_HOME} ${SKLM_ADMIN_USER} ${MIG_LOG_PATH} 0 

${WAS_HOME}/bin/wsadmin.sh -lang jython -username ${WAS_ADMIN_ID} -password ${WAS_ADMIN_PASSWORD} -f ${SKLM_INSTALL_PATH}/migration/bin/migrateAddRolesandUsers2Roles.py ${TKLM_TIP_HOME} ${SKLM_INSTALL_PATH} ${MIG_LOG_PATH}

${WAS_HOME}/bin/wsadmin.sh -lang jython -profileName KLMProfile -username ${WAS_ADMIN_ID} -password ${WAS_ADMIN_PASSWORD} -f ${SKLM_INSTALL_PATH}/migration/bin/migrateAddRolesandUsers2Roles2V25.py ${WAS_HOME} ${SKLM_INSTALL_PATH} ${MIG_LOG_PATH}

${WAS_HOME}/bin/wsadmin.sh -lang jython -profileName KLMProfile -username ${WAS_ADMIN_ID} -password ${WAS_ADMIN_PASSWORD} -f ${SKLM_INSTALL_PATH}/migration/bin/migrateUsers.py ${TKLM_TIP_HOME} ${WAS_HOME} ${SKLM_ADMIN_USER} ${MIG_LOG_PATH} 1

MIG_CP=${SKLM_INSTALL_PATH}/migration/com.ibm.sklm.migration.jar:${WAS_HOME}/universalDriver/lib/db2jcc4.jar:${WAS_HOME}/lib/j2ee.jar:${WAS_HOME}/plugins/com.ibm.icu.jar:${WAS_HOME}/plugins/com.ibm.tklm.commands.jar:${WAS_HOME}/java/8.0/jre/lib/ext/ibmkeycert.jar:${WAS_HOME}/java/8.0/jre/lib/ext/ibmpkcs11impl.jar:${WAS_HOME}/java/8.0/jre/lib/ext/ibmjcefips.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.obfuscation.jar;

shopt -s nullglob
for f in ${IM_INSTALL_DIR}/plugins/com.ibm.cic.common.core_*.jar
do
	MIG_CP=${MIG_CP}:$f
done
for f in ${IM_INSTALL_DIR}/plugins/org.eclipse.core.runtime_*.jar
do
	MIG_CP=${MIG_CP}:$f
done
for f in ${IM_INSTALL_DIR}/plugins/org.eclipse.osgi*.jar
do
	MIG_CP=${MIG_CP}:$f
done
for f in ${IM_INSTALL_DIR}/plugins/org.apache.commons*.jar
do
	MIG_CP=${MIG_CP}:$f
done
for f in ${IM_INSTALL_DIR}/plugins/org.eclipse.equinox.common*.jar
do
	MIG_CP=${MIG_CP}:$f
done
for f in ${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/lib/*.jar
do
    MIG_CP=${MIG_CP}:$f
done

${JAVA_HOME}/bin/java -cp ${MIG_CP} com.ibm.sklm.im.helper.MigrationRunner ${WAS_ADMIN_ID} ${WAS_ADMIN_PASSWORD} ${TKLM_DB_PWD} ${KEYSTORE_PWD} ${TKLM_VERSION} ${MIG_LOG_PATH} ${TKLM_TIP_HOME} ${WAS_HOME} ${SKLM_INSTALL_PATH} ${SKLM_ADMIN_USER} ${SKLM_ADMIN_USER_PASSWORD}

exit 0