@echo off
SET CURR_DIR=%~dp0
echo CURR_DIR %CURR_DIR%
:: Keep variables local
SETLOCAL
SET EKM_HOME=
SET KLM_VERSION=
SET BACKUP_DIR=
SET BACKUP_PASSWORD=





if not exist backup.properties goto noconfig

for /f "tokens=1,2,3 delims==" %%a in (backup.properties) do (
  
  if "%%a"=="KLM_VERSION" set KLM_VERSION=%%b
  if "%%a"=="BACKUP_DIR" set BACKUP_DIR=%%b
  if "%%a"=="EKM_HOME" set EKM_HOME=%%b
  if "%%a"=="BACKUP_PASSWORD" set BACKUP_PASSWORD=%%b
  if "%%a"=="JAVA_HOME" set JAVA_HOME=%%b
  )
  
if "%JAVA_HOME%"=="" (
 echo.
 echo JAVA_HOME Variable not set. Set the JAVA_HOME environment variable and try again.
 goto end
)  

if not exist "%JAVA_HOME%\\bin\\java.exe" (
 echo.
 echo Invalid JAVA_HOME directory set.
 goto end	
)
  
if "%EKM_HOME%"=="" (
 echo.
 echo EKM_HOME Property is empty.
 goto end
)

if not exist "%EKM_HOME%\\KeyManagerConfig.properties" (
 echo.
 echo EKM_HOME must contain KeyManagerConfig.properties file.
 goto end	
)


if "%BACKUP_PASSWORD%"=="" (
 echo.
 echo BACKUP_PASSWORD Property is empty.
 goto end
)

if "%KLM_VERSION%"=="" (
 	set KLM_VERSION=2.1
)else (
if NOT "%KLM_VERSION%"=="2.1" (
	echo.
 	echo For EKM backup only EKM version 2.1 is supported.
 	goto end
)
)

goto run

:noconfig
@echo Cannot find backup.properties. The parameter values cannot be determined. Run this script again by specifying the following parameters in backup.properties
@echo EKM_HOME
@echo KLM_VERSION
@echo BACKUP_DIR
@echo BACKUP_PASSWORD
@echo JAVA_HOME
if "%%a"=="EKM_HOME" set EKM_HOME=%%b
if "%%a"=="KLM_VERSION" set KLM_VERSION=%%b
if "%%a"=="BACKUP_DIR" set BACKUP_DIR=%%b
if "%%a"=="BACKUP_PASSWORD" set BACKUP_PASSWORD=%%b
if "%%a"=="JAVA_HOME" set JAVA_HOME=%%b
goto end
  
:run

echo.
SET BACKUP_CP=%CURR_DIR%com.ibm.sklm.server.migrate.ekm21.jar;%CURR_DIR%IBMKeyManagementServer.jar
rem call :BACKUP_CLASSPATH
echo starting backup operation..
"%JAVA_HOME%/bin/java.exe" -cp "%BACKUP_CP%" com.ibm.sklm.server.migrate.ekm21.backup.BackupHandlerEKM21 "%EKM_HOME%" > backup_console.log 2>&1
set rc=%ERRORLEVEL%
if NOT %rc%==0 (
	echo Backup completed with errors, Please refer to backup.log for more details.
)
if %rc%==0 (
	echo Backup completed, Please refer to backup.log for more details.
)

goto end

:end
