#!/bin/sh

CURR_DIR=`pwd`
CURR_DIR=${CURR_DIR}/
echo "CURR_DIR=${CURR_DIR}"



if [ ! -f backup.properties ]
then
echo "backup.properties file not found."
exit 1
fi

. ./backup.properties

if [ -z ${JAVA_HOME} ]
then
echo "JAVA_HOME property not set."
exit 1
fi

if [ ! -d ${JAVA_HOME} ]
then
echo "JAVA_HOME variable not set."
exit 1
fi

if [ ! -f ${JAVA_HOME}/bin/java ]
then
echo "Invalid JAVA_HOME directory set."
exit 1
fi

if [ -z ${EKM_HOME} ] 
then 
echo "EKM_HOME variable not set."
exit 1
fi

if [ ! -f ${EKM_HOME}/KeyManagerConfig.properties ]
then
echo "EKM_HOME directory must contain KeyManagerConfig.properties file."
exit 1
fi

if [ -z ${BACKUP_PASSWORD} ]
then 
echo "BACKUP_PASSWORD Property is empty"
exit 1
fi

if [ -z ${KLM_VERSION} ] 
then
echo "KLM_VERSION Property is empty"
exit 1
fi

BACKUP_CP=${CURR_DIR}com.ibm.sklm.server.migrate.ekm21.jar:${CURR_DIR}IBMKeyManagementServer.jar

#echo "****** BACKUP_CP ${BACKUP_CP}*******"

#echo "****** BACKUP_CP ${BACKUP_CP}*******"


#echo "${JAVA_HOME}/bin/java -cp ${BACKUP_CP} com.ibm.sklm.server.migrate.v2v.backup.BackupHandlerV2V ${EKM_HOME}"
echo "starting backup operation.."
${JAVA_HOME}/bin/java -cp ${BACKUP_CP} com.ibm.sklm.server.migrate.ekm21.backup.BackupHandlerEKM21 ${EKM_HOME} > backup_console.log 2>&1
rc=$?
if [ $rc -ne 0 ]; then
   	echo "Backup completed with errors, please refer to backup.log for more details."
else
	echo "Backup completed, please refer to backup.log for more details."
fi

exit 0
