#!/bin/bash

CURR_DIR=`pwd`
CURR_DIR=${CURR_DIR}/
echo "CURR_DIR=${CURR_DIR}"

export PATH=${PATH}:.

if [ ! -f backup.properties ]
then
echo "Cannot find backup.properties. The parameter values cannot be determined. Run this script again by specifying the following parameters in backup.properties"
echo WAS_HOME
echo DB_PASSWORD
echo WAS_USER_PWD
echo BACKUP_PASSWORD
exit 1
fi

. ./backup.properties

if [ -z ${WAS_HOME} ]
then 
echo "WAS_HOME Property is empty"
exit 1
fi

export WAS_HOME=${WAS_HOME}
if [ !  ${JAVA_HOME} ]
then
export JAVA_HOME=${WAS_HOME}/java
fi
if [ -z ${WAS_USER_PWD} ]
then 
echo "WAS_USER_PWD Property is empty"
exit 1
fi
if [ -z ${DB_PASSWORD} ]
then 
echo "DB_PASSWORD Property is empty"
exit 1
fi
if [ -z ${BACKUP_PASSWORD} ]
then 
echo "BACKUP_PASSWORD Property is empty"
exit 1
fi

if [ !  ${JAVA_HOME} ]
then
export JAVA_HOME=${WAS_HOME}/java
fi

if [ ! -d ${JAVA_HOME} ]
then
echo "JAVA_HOME ${JAVA_HOME} is not directory."
exit 1
fi


BACKUP_CP=${CURR_DIR}com.ibm.sklm.server.migrate.sklmv25.jar:${CURR_DIR}rt.jar:${CURR_DIR}xml.jar:${WAS_HOME}/universalDriver/lib/db2jcc.jar:${WAS_HOME}/universalDriver/lib/db2jcc_license_cu.jar:${WAS_HOME}/lib/j2ee.jar:${WAS_HOME}/plugins/com.ibm.icu.jar:${WAS_HOME}/plugins/com.ibm.tklm.commands.jar:${WAS_HOME}/java/jre/lib/ext/ibmkeycert.jar:${WAS_HOME}/java/jre/lib/ext/ibmpkcs11impl.jar:${WAS_HOME}/java/jre/lib/ext/ibmjcefips.jar:${WAS_HOME}/lib/ext/com.ibm.tklm.passwordpolicy.jar

#echo "****** BACKUP_CP ${BACKUP_CP}*******"

shopt -s nullglob
for f in ${WAS_HOME}/plugins/*.jar
do
	BACKUP_CP=${BACKUP_CP}:$f
done
for f in ${WAS_HOME}/lib/*.jar
do
	BACKUP_CP=${BACKUP_CP}:$f
done
for f in ${WAS_HOME}/profiles/KLMProfile/installedApps/SKLMCell/sklm_kms.ear/*.jar
do
	BACKUP_CP=${BACKUP_CP}:$f
done

#echo "****** BACKUP_CP ${BACKUP_CP}*******"


#echo "${JAVA_HOME}/bin/java -cp ${BACKUP_CP} com.ibm.sklm.server.migrate.v2v.backup.BackupHandlerV2V ${WAS_HOME}"

${JAVA_HOME}/bin/java -cp ${BACKUP_CP} com.ibm.sklm.server.migrate.v2v.backup.BackupHandlerV2V ${WAS_HOME} > backup_console.log 2>&1
rc=$?
if [ $rc -ne 0 ]; then
   	echo "Backup completed with errors, please refer to backup.log for more details."
else
	echo "Backup completed, please refer to backup.log for more details."
fi

exit 0
