@echo off
SET CURR_DIR=%~dp0
rem echo CURR_DIR %CURR_DIR%
:: Keep variables local
SETLOCAL
SET WAS_HOME=
SET TKLM_TIP_HOME=
SET DB_PASSWORD=
SET KEYSTORE_PASSWORD=
SET TIP_USER_PWD=
SET BACKUP_PASSWORD=

if not exist backup.properties goto noconfig

for /f "tokens=1,2,3 delims==" %%a in (backup.properties) do (
  
  if "%%a"=="WAS_HOME" set TKLM_TIP_HOME=%%b
  if "%%a"=="WAS_HOME" set WAS_HOME=%%b
  if "%%a"=="WAS_USER_PWD" set WAS_USER_PWD=%%b
  if "%%a"=="KEYSTORE_PASSWORD" set KEYSTORE_PASSWORD=%%b
  if "%%a"=="DB_PASSWORD" set DB_PASSWORD=%%b
  if "%%a"=="BACKUP_PASSWORD" set BACKUP_PASSWORD=%%b
  if "%%a"=="JAVA_HOME" set JAVA_HOME=%%b
  )

if "%JAVA_HOME%"=="" (
	 echo JAVA_HOME not set.
	 goto end	
)  
  
if "%WAS_HOME%"=="" (
 echo.
 echo WAS_HOME Property is empty.
 goto end
)

if not exist "%WAS_HOME%/bin/wsadmin.bat" (
	echo.
	echo Invalid WAS_HOME directory set.
	goto end
)

if not "%JAVA_HOME%"=="" (
	if not exist "%JAVA_HOME%\\bin\\java.exe" (
	 echo.
	 echo Invalid JAVA_HOME directory set.
	 goto end	
	)
)

if "%WAS_USER_PWD%"=="" (
 echo.
 echo WAS_USER_PWD Property is empty.
 goto end
)


if "%DB_PASSWORD%"=="" (
 echo.
 echo DB_PASSWORD Property is empty.
 goto end
)

if "%BACKUP_PASSWORD%"=="" (
 echo.
 echo BACKUP_PASSWORD Property is empty.
 goto end
)


goto run

:noconfig
@echo Cannot find backup.properties. The parameter values cannot be determined. Run this script again by specifying the following parameters in backup.properties
@echo WAS_HOME
@echo DB_PASSWORD
@echo WAS_USER_PWD
@echo BACKUP_PASSWORD
goto end
  
:run

echo.
SET BACKUP_CP=%CURR_DIR%com.ibm.sklm.server.migrate.sklmv30.jar;%WAS_HOME%/universalDriver/lib/db2jcc.jar;%WAS_HOME%/universalDriver/lib/db2jcc_license_cu.jar;%WAS_HOME%/lib/j2ee.jar;%WAS_HOME%/plugins/com.ibm.icu.jar;%WAS_HOME%/plugins/com.ibm.tklm.commands.jar;%WAS_HOME%/java/8.0/jre/lib/ext/ibmkeycert.jar;%WAS_HOME%/java/8.0/jre/lib/ext/ibmpkcs11impl.jar;%WAS_HOME%/java/8.0/jre/lib/ext/ibmjcefips.jar;%WAS_HOME%/plugins/com.ibm.ws.runtime.jar;%WAS_HOME%/plugins/com.ibm.ws.emf.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.jar;%WAS_HOME%/plugins/org.eclipse.emf.common.jar;%WAS_HOME%/plugins/com.ibm.ffdc.jar;%WAS_HOME%/plugins/com.ibm.ws.prereq.xlxp.jar;%WAS_HOME%/plugins/com.ibm.ws.runtime.wim.base.jar;%WAS_HOME%/plugins/com.ibm.ws.runtime.wim.core.jar;%WAS_HOME%/plugins/com.ibm.ws.admin.core.jar;%WAS_HOME%/plugins/org.eclipse.emf.commonj.sdo.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.sdo.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.xmi.jar;%WAS_HOME%/plugins/org.eclipse.emf.ecore.change.jar;%WAS_HOME%/plugins/com.ibm.sec.authz.ibmsecauthz_7.3.1.jar;%WAS_HOME%\lib\ext\com.ibm.tklm.passwordpolicy.jar;%WAS_HOME%\lib\ext\com.ibm.tklm.obfuscation.jar
rem echo BACKUP_CP=%BACKUP_CP%
rem echo BACKUP_CP="%WAS_HOME%\plugins\"
call :BACKUP_CLASSPATH
rem echo BACKUP_CP=%BACKUP_CP%
rem "%JAVA_HOME%/bin/java.exe" -Xdebug -Xrunjdwp:server=y,transport=dt_socket,address=8888,suspend=y -cp "%BACKUP_CP%" com.ibm.sklm.server.migrate.v2v.backup.BackupHandlerV2V "%WAS_HOME%"
if "%JAVA_HOME%"=="" (
"%WAS_HOME%/java/bin/java.exe" -cp "%BACKUP_CP%" com.ibm.sklm.server.migrate.v2v.backup.BackupHandlerV2V "%WAS_HOME%" > backup_console.log 2>&1
) else (
"%JAVA_HOME%/bin/java.exe" -cp "%BACKUP_CP%" com.ibm.sklm.server.migrate.v2v.backup.BackupHandlerV2V "%WAS_HOME%" > backup_console.log 2>&1
)
set rc=%ERRORLEVEL%
if NOT %rc%==0 (
	echo Backup is completed with errors. Please check logs for backup status and details.
)
if %rc%==0 (
	echo Backup is completed. Please check logs for backup status and details.
)
goto end

:BACKUP_CLASSPATH
for %%i in ("%WAS_HOME%\profiles\KLMProfile\installedApps\SKLMCell\sklm_kms.ear\*.jar") do call :SETCP %%i
for %%i in ("%WAS_HOME%\lib\*.jar") do call :SETCP %%i


:SETCP
set BACKUP_CP=%BACKUP_CP%;%*

:end
