#! /bin/bash

printusage() {
echo "*************************************************************
Usage: 
    ./changeOwnership.sh FOLDER_PATH OWNER_USER
    where
    FOLDER_PATH is the directory to change owner
    OWNER_USER is new owner of above dorectory
     
	
Example : ./changeOwnership.sh 	/home/sklmdbxx sklmuser

*************************************************************"
exit 1
}



if [ $# -ne 2 ]; then
	printusage
else
	folderPath=$1
	ownerUser=$2
fi


if [ "${folderPath}" = "" ]; then
   printusage
fi
if [ "${ownerUser}" = "" ]; then
   printusage
fi

if [ ! -d ${folderPath} ]
then
echo "Check if the parameter FOLDER_PATH is set to the valid directory."
exit 1
fi

chown -R ${ownerUser} ${folderPath}
exit 0
