#!/bin/sh

### BEGIN INIT INFO
# Provides: DB2SKLMV41
# Required-Start: $local_fs
# Required-Stop: $local_fs
# X-Start-Before: $network
# X-Stop-After: $network
# Default-Start: 2 3 4 5
# Default-Stop: 0 6
# Short-Description: DB2 instance processes
### END INIT INFO


DB2_INSTALL_PATH=/opt/IBM/DB2SKLMV41/

list_instances() {
$DB2_INSTALL_PATH/bin/db2greg -dump | grep -E '^I,DB2' | \
cut -d, --output-delimiter=" " -s -f4,5,7
}

case "$1" in
start)
echo "Starting DB2 instances "
# read DB2 instances from the global registry
list_instances | while read INST INSTDIR AUTOSTART >> /root/db2log
do
if [ $AUTOSTART -eq 1 ]
then
echo -n " $INST"
su - $INST -c $INSTDIR/adm/db2start>>/root/db2log& # send to background
fi
done
;;
status)
echo "Checking for DB2 instances..."
list_instances | while read INST INSTDIR AUTOSTART
do
ps aux | grep db2sys | awk  '{print $1}' | grep sklmdb27 | while read INSTNAME
do
if [ "$INSTNAME" == "sklmdb27" ]
then
echo -n " $INSTNAME                        		running " 
echo
fi
done
done
;;
stop)
echo "Stopping DB2 instances..."
list_instances | while read INST INSTDIR AUTOSTART
do
#checkproc $INSTDIR/adm/db2sysc
#RC=$?
#if [ $RC -eq 0 ]
#then
echo -n " $INST"
su - $INST -c "$INSTDIR/adm/db2stop force">/dev/null # wait for it to stop
#rc_status -v
#fi
done
;;
*)
echo "Usage: $0 {start|stop|status}"
exit 1
;;
esac
