#!/bin/sh
. /etc/rc.status

rc_reset

DB2_INSTALL_PATH=/opt/IBM/DB2SKLMV41/

list_instances() {
$DB2_INSTALL_PATH/bin/db2greg -dump | grep -E '^I,DB2' | \
cut -d, --output-delimiter=" " -s -f4,5,7
}

case "$1" in
start)
echo "Starting DB2 instances "
# read DB2 instances from the global registry
list_instances | while read INST INSTDIR AUTOSTART
do
if [ $AUTOSTART -eq 1 ]
then
echo -n " $INST"
su - $INST -c $INSTDIR/adm/db2start>/dev/null& # send to background
rc_status -v
fi
done
;;

status)
echo "Checking for DB2 instances..."
list_instances | while read INST INSTDIR AUTOSTART
do
echo -n " $INST"
checkproc $INSTDIR/adm/db2sysc
rc_status -v
done
;;
stop)
echo "Stopping DB2 instances..."
list_instances | while read INST INSTDIR AUTOSTART
do
checkproc $INSTDIR/adm/db2sysc
RC=$?
if [ $RC -eq 0 ]
then
echo -n " $INST"
su - $INST -c "$INSTDIR/adm/db2stop force">/dev/null # wait for it to stop
rc_status -v
fi	
done
;;
*)
echo "Usage: $0 {start|stop|status}"
exit 1
;;
esac
rc_exit
