#!/bin/bash
############################################################################################### 
# Licensed Materials - Property of IBM
#
# 5724-T60 5608-A91
# (C) Copyright IBM Corp. 2019  All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication, or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
###############################################################################################
SERVERNAME=$1
WASHOME=$2
WASUSER=$3
DBUSER=$4
DBHOME=$5
RUNASUSER=$6
olddb2servicefullpath="/etc/rc.d/init.d/SecurityKeyLifecycleManager301_was"
oldstartService="/etc/rc.d/rc2.d/Sz99_SecurityKeyLifecycleManager301_was"
oldstopService="/etc/rc.d/rc2.d/Kz99_SecurityKeyLifecycleManager301_was"
db2servicefullpath="/etc/rc.d/init.d/SecurityKeyLifecycleManager_was"
startService="/etc/rc.d/rc2.d/Sz99_SecurityKeyLifecycleManager_was"
stopService="/etc/rc.d/rc2.d/Kz99_SecurityKeyLifecycleManager_was"
#Creating service file

if [ -e ${oldstartService} ]; then
	rm ${oldstartService}
fi

if [ -e ${oldstopService} ]; then
	rm ${oldstopService}
fi

if [ -e ${olddb2servicefullpath} ]; then
	rm ${olddb2servicefullpath}
fi

if [ -e ${stopService} ]; then
	rm ${stopService}
fi

if [ -e ${startService} ]; then
	rm ${startService}
fi

if [ -e ${db2servicefullpath} ]; then
	rm ${db2servicefullpath}
fi

echo \#!/bin/ksh >> ${db2servicefullpath}
echo \# >> ${db2servicefullpath}
echo 
echo "###############################################################################################" >> ${db2servicefullpath}
echo \# Licensed Materials - Property of IBM >> ${db2servicefullpath}
echo \# >> ${db2servicefullpath}
echo \# 5724-T60 5608-A91 >> ${db2servicefullpath}
echo \# \(C\) Copyright IBM Corp. 2019  All Rights Reserved >> ${db2servicefullpath}
echo \# >> ${db2servicefullpath}
echo \# US Government Users Restricted Rights - Use, duplication, or >> ${db2servicefullpath}
echo \# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. >> ${db2servicefullpath}
echo \# >> ${db2servicefullpath}
echo "###############################################################################################" >> ${db2servicefullpath}
echo 
echo SERVERNAME=\"${SERVERNAME}\" >> ${db2servicefullpath}
echo PROFILEPATH=\"${WASHOME}/profiles/KLMProfile\" >> ${db2servicefullpath}
echo WASHOME=\"${WASHOME}\" >> ${db2servicefullpath}
echo STARTARGS=\"\" >> ${db2servicefullpath}
echo STOPARGS=\"-username ${WASUSER} -password ****\" >> ${db2servicefullpath}
echo SERVICENAME=\"SecurityKeyLifecycleManager_was\" >> ${db2servicefullpath}
echo RUNASUSER=\"${DBUSER}\" >> ${db2servicefullpath}
echo DBUSER=\"${DBUSER}\" >> ${db2servicefullpath}
echo DBHOME=\"${DBHOME}\" >> ${db2servicefullpath}
echo # END BLOCK >> ${db2servicefullpath}
echo 
echo startScript=startServer.sh >> ${db2servicefullpath}
echo stopScript=stopServer.sh >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo binDir=\"\${PROFILEPATH}/bin\" >> ${db2servicefullpath}
echo LOCKFILE=\"/var/lock/subsys/\${SERVICENAME}\" >> ${db2servicefullpath}
echo RETVAL=0 >> ${db2servicefullpath}


db2StartCommand=${DBHOME}/sqllib/adm/db2start
db2StopCommand="${DBHOME}/sqllib/adm/db2stop force"
awk  -v command="${db2StartCommand}" '/start db2/{print;print command;next}1' /${DBHOME}/sqllib/db2start.sh > temp
mv temp /${DBHOME}/sqllib/db2start.sh
awk -v command="${db2StopCommand}" '/stop db2/{print;print command;next}1' /${DBHOME}/sqllib/db2stop.sh > temp
mv temp /${DBHOME}/sqllib/db2stop.sh


echo start_db2\(\) >> ${db2servicefullpath}
echo { >> ${db2servicefullpath}
echo "    "su - \${DBUSER} \${DBHOME}/sqllib/db2start.sh >> ${db2servicefullpath}
echo } >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo stop_db2\(\) >> ${db2servicefullpath}
echo { >> ${db2servicefullpath}
echo "    "su - \${DBUSER} \${DBHOME}/sqllib/db2stop.sh >> ${db2servicefullpath}
echo } >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo start_was\(\) >> ${db2servicefullpath}
echo { >> ${db2servicefullpath}
echo "    "startCmd=\"\${binDir}/\${startScript}\" >> ${db2servicefullpath}
echo "    " if [ -f \"\${startCmd}\" -a -x \"\${startCmd}\" ] \; \then >> ${db2servicefullpath}
echo "           " echo \"Starting WebSphere Application Server - \${SERVERNAME} ...\" >> ${db2servicefullpath}
echo "           " if [ -z \"\${RUNASUSER}\" ]\; \then >> ${db2servicefullpath}
echo "           "   \"\${startCmd}\" \"\${SERVERNAME}\" \${STARTARGS} \$@ >> ${db2servicefullpath}
echo "           " else >> ${db2servicefullpath}
echo "           "   su - \${RUNASUSER} -c \"\\\"\${startCmd}\\\" \\\"\${SERVERNAME}\\\" \${STARTARGS} \$@\" >> ${db2servicefullpath}
echo "           " fi >> ${db2servicefullpath}
echo "           " RETVAL=\$? >> ${db2servicefullpath}
echo "           " [ \$RETVAL -eq 0 ] \&\& \touch \"\${LOCKFILE}\" >> ${db2servicefullpath}
echo "    " else >> ${db2servicefullpath}
echo "           " echo \"Failure starting WebSphere Application Server - \${SERVERNAME}\" >> ${db2servicefullpath}
echo "           " echo \"The service definition may be invalid - script \${startCmd}\" >> ${db2servicefullpath}
echo "           " echo \"could not be found or was not executable.\" >> ${db2servicefullpath}
echo "    " fi >> ${db2servicefullpath}
echo } >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo stop_was\(\) >> ${db2servicefullpath}
echo { >> ${db2servicefullpath}
echo "    " stopCmd=\"\${binDir}/\${stopScript}\" >> ${db2servicefullpath}
echo "    " if [ -f \"\${stopCmd}\" -a -x \"\${stopCmd}\" ] \; \then >> ${db2servicefullpath}
echo "           " echo \"Stopping WebSphere Application Server - \$SERVERNAME ...\" >> ${db2servicefullpath}
echo "           " if [ \-z \"\${RUNASUSER}\" ]\; \then >> ${db2servicefullpath}
echo "           "   \"\${stopCmd}\" \"\${SERVERNAME}\" \${STOPARGS} \$@ >> ${db2servicefullpath}
echo "           " else >> ${db2servicefullpath}
echo "           "   su - \${RUNASUSER} -c \"\\\"\${stopCmd}\\\" \\\"\${SERVERNAME}\\\" \${STOPARGS} \$@\" >> ${db2servicefullpath}
echo "           " fi >> ${db2servicefullpath}
echo "           " RETVAL=\$? >> ${db2servicefullpath}
echo "           " [ \$RETVAL -eq 0 ] \&\& \rm -f \"\${LOCKFILE}\" >> ${db2servicefullpath}
echo "    " else >> ${db2servicefullpath}
echo "           " echo \"Failure stopping WebSphere Application Server - \${SERVERNAME}\" >> ${db2servicefullpath}
echo "           " echo \"The service definition may be invalid - script \${stopCmd}\" >> ${db2servicefullpath}
echo "           " echo \"could not be found or was not executable.\" >> ${db2servicefullpath}
echo "    " fi >> ${db2servicefullpath} 
echo } >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo stat_was\(\) >> ${db2servicefullpath}
echo { >> ${db2servicefullpath}
echo "    " if ps ax \| \grep -v grep \| \grep \"\${PROFILEPATH}\" \| \grep \"\${SERVERNAME}\" \> /dev/null \; \then >> ${db2servicefullpath}
echo "           " echo \"WebSphere Application Server - \$SERVERNAME is running.\" >> ${db2servicefullpath}
echo "    " else >> ${db2servicefullpath}
echo "           " echo \"WebSphere Application Server - \$SERVERNAME is not running.\" >> ${db2servicefullpath}
echo "    " fi >> ${db2servicefullpath}
echo } >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo case \"\$1\" in >> ${db2servicefullpath}
echo   start\) >> ${db2servicefullpath}
echo "    " shift >> ${db2servicefullpath}
echo "    " start_db2 >> ${db2servicefullpath}
echo "    " start_was \$@ >> ${db2servicefullpath}
echo "    " \;\; >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo   stop\) >> ${db2servicefullpath}
echo "    " shift >> ${db2servicefullpath}
echo "    " stop_was \$@ >> ${db2servicefullpath}
echo "    " \;\; >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo   restart\) >> ${db2servicefullpath}
echo "    " stop_was >> ${db2servicefullpath}
echo "    " start_was >> ${db2servicefullpath}
echo "    " \;\; >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo   status\) >> ${db2servicefullpath}
echo "    " stat_was >> ${db2servicefullpath}
echo "    " \;\; >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo   *\) >> ${db2servicefullpath}
echo "    " echo \"Usage: \$0 {start\|stop\|status\|restart}\" >> ${db2servicefullpath}
echo "    " exit 1 >> ${db2servicefullpath}
echo "    " \;\; >> ${db2servicefullpath}
echo esac >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo if [ \$RETVAL -ne 0 ]\; \then >> ${db2servicefullpath}
echo "    " echo exit code: \$RETVAL >> ${db2servicefullpath}
echo fi >> ${db2servicefullpath}
echo  >> ${db2servicefullpath}
echo exit \$RETVAL >> ${db2servicefullpath}

chmod +x ${db2servicefullpath}

ln -s ${db2servicefullpath} ${startService}
ln -s ${db2servicefullpath} ${stopService}

${db2servicefullpath} start

exit 0
