import sys
import os.path

SUCCESS = "SUCCESS"
FAILURE = "FAILURE"

######### Update SKLM data source #########

def loadValues (dataSourceId):
	global AdminConfig
	propSetId = AdminConfig.list('J2EEResourcePropertySet',dataSourceId);
	props = AdminConfig.showall(propSetId);
	global dbName
	dbName = ""
	global primaryDbServerName
	primaryDbServerName = ""
	global primaryDbportNumber
	primaryDbportNumber = ""	
	global alternateServerName
	alternateServerName = ""
	global alternatePortNumber
	alternatePortNumber = ""
	if (props != ""):
		#get database name
		dbName = props[props.index("databaseName"):]
		dbName = dbName[dbName.index("value"):]
		dbName = dbName[dbName.index("value") + 6 : dbName.index("]")]

		#get primary server name		
		primaryDbServerName = props[props.index("serverName"):]
		primaryDbServerName = primaryDbServerName[primaryDbServerName.index("value"):]
		primaryDbServerName = primaryDbServerName[primaryDbServerName.index("value") + 6 : primaryDbServerName.index("]")]

		#get primary port		
		primaryDbportNumber = props[props.index("portNumber"):]
		primaryDbportNumber = primaryDbportNumber[primaryDbportNumber.index("value"):]
		primaryDbportNumber = primaryDbportNumber[primaryDbportNumber.index("value") + 6 : primaryDbportNumber.index("]")]

		if (props.find("clientRerouteAlternatePortNumber") != -1):
			#get alternate server Name			
			alternateServerName  = props[props.index("clientRerouteAlternateServerName"):]
			alternateServerName = alternateServerName[alternateServerName.index("value"):]
			alternateServerName = alternateServerName[alternateServerName.index("value") + 6 : alternateServerName.index("]")]

			#get alternate server port
			alternatePortNumber  = props[props.index("clientRerouteAlternatePortNumber"):]
			alternatePortNumber = alternatePortNumber[alternatePortNumber.index("value"):]
			alternatePortNumber = alternatePortNumber[alternatePortNumber.index("value") + 6 : alternatePortNumber.index("]")]
		else:
			return FAILURE
		return SUCCESS
	else:
		print "properties value not exists"
		return FAILURE
	#endElse
#endDef

def update_sklm_datasource (dataSourceId, dsName):
	global AdminConfig

	print "--> proc update_sklm_datasource"
	print "--> SKLM dataSourceId is " + dataSourceId

	if (dataSourceId != ""):    
		propSet = AdminConfig.create("J2EEResourcePropertySet", dataSourceId, [] )
		attrs = [["name", "databaseName"], ["type", "java.lang.String"], ["value", dbName]]
		AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		attrs = [["name", "driverType"], ["type", "java.lang.Integer"], ["value", 4]]
		AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		attrs = [["name", "serverName"], ["type", "java.lang.String"], ["value", primaryDbServerName]]
		AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		attrs = [["name", "portNumber"], ["type", "java.lang.Integer"], ["value", primaryDbportNumber]]
		AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		attrs = [["name", "retryIntervalForClientReroute"], ["type", "java.lang.Integer"], ["description", ""], ["value", 10], ["required", "false"]]
		AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		attrs = [["name", "maxRetriesForClientReroute"], ["type", "java.lang.Integer"], ["description", ""], ["value", 2], ["required", "false"]]
		AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		
		if (primaryDbServerName != alternateServerName and dsName == "SKLM scheduler"):
			attrs = [["name", "clientRerouteAlternateServerName"], ["type", "java.lang.String"], ["description", ""], ["value", alternateServerName], ["required", "false"]]
			AdminConfig.create("J2EEResourceProperty", propSet, attrs)
			attrs = [["name", "clientRerouteAlternatePortNumber"], ["type", "java.lang.String"], ["description", ""], ["value", alternatePortNumber], ["required", "false"]]
			AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		return SUCCESS
	else:
		return FAILURE
	#endElse
#endDef

def update_sklm_alternate_datasource (dataSourceId):
	global AdminConfig

	print "--> proc update_sklm_datasource"
	print "--> SKLM dataSourceId is " + dataSourceId
	
	if (dataSourceId != ""):
		standbyNameList =  alternateServerName.split(",",1);
		standbyPortList =  alternatePortNumber.split(",",1);
		auxiliaryServerName=""
		if len(standbyNameList) > 1:
			principalStandbyServerName = standbyNameList[0]
			auxiliaryServerName = standbyNameList[1]
			principalStandbyportNumber = standbyPortList[0]
			auxiliaryPortNumber = standbyPortList[1]
		else:
			principalStandbyServerName = standbyNameList[0]
			principalStandbyportNumber = standbyPortList[0]
		#endElse
		
		propSet = AdminConfig.create("J2EEResourcePropertySet", dataSourceId, [] )
		attrs = [["name", "databaseName"], ["type", "java.lang.String"], ["value", dbName]]
		AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		attrs = [["name", "driverType"], ["type", "java.lang.Integer"], ["value", 4]]
		AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		attrs = [["name", "serverName"], ["type", "java.lang.String"], ["value", principalStandbyServerName]]
		AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		attrs = [["name", "portNumber"], ["type", "java.lang.Integer"], ["value", principalStandbyportNumber]]
		AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		attrs = [["name", "retryIntervalForClientReroute"], ["type", "java.lang.Integer"], ["description", ""], ["value", 10], ["required", "false"]]
		AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		attrs = [["name", "maxRetriesForClientReroute"], ["type", "java.lang.Integer"], ["description", ""], ["value", 2], ["required", "false"]]
		AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		if auxiliaryServerName != "":
			attrs = [["name", "clientRerouteAlternateServerName"], ["type", "java.lang.String"], ["description", ""], ["value", auxiliaryServerName], ["required", "false"]]
			AdminConfig.create("J2EEResourceProperty", propSet, attrs)
			attrs = [["name", "clientRerouteAlternatePortNumber"], ["type", "java.lang.String"], ["description", ""], ["value", auxiliaryPortNumber], ["required", "false"]]
			AdminConfig.create("J2EEResourceProperty", propSet, attrs)
		
		return SUCCESS
	else:
		return FAILURE
	#endElse
#endDef


#####################################################
#													#
# 				SCRIPT STARTS HERE					#
#													#
# 		 Sets up WAS to configure DB2 HADR			#
#													#
#####################################################

if (len(sys.argv) != 1):
	print "  "
	print "Incorrect number of args.  "
	print "   arg1 - WAS_HOME"
	sys.exit(1)
#endIf

WAS_HOME = sys.argv[0]

configPath = WAS_HOME +"/products/sklm/config/MMConfig.properties"
if not (os.path.isfile(configPath)) :
	sys.exit(1)

multiMasterRole = ""
with open(configPath, "rt") as f:
	for line in f:
		l = line.strip()
		key_value = l.split("=")
		key = key_value[0].strip()
		if (key == "multimasterRole"):
			value = key_value[1].strip().strip('"') 
			multiMasterRole = value

if(multiMasterRole == ""):
	sys.exit(0)

#UPDATE SKLM DataSource
dataSourceId = AdminConfig.list('DataSource', 'SKLM DataSource*')
returnCode = loadValues(dataSourceId)

if(returnCode != SUCCESS):
	sys.exit(0)

#UPDATE SKLM DataSource
dataSourceId = AdminConfig.list('DataSource', 'SKLM DataSource*')
returnCode = update_sklm_datasource(dataSourceId, "SKLM DataSource")

print "Debug --> return from update_sklm_datasource SKLM DataSource : " + returnCode
if (returnCode == SUCCESS):
		AdminConfig.save( )
#endIf

#UPDATE Alternate SKLM DataSource
dataSourceId = AdminConfig.list('DataSource', 'SKLM Alternate XA Datasource*')
returnCode = update_sklm_alternate_datasource(dataSourceId)

print "Debug --> return from update_sklm_alternate_datasource SKLM Alternate DataSource : " + returnCode
if (returnCode == SUCCESS):
		AdminConfig.save( )
#endIf


#UPDATE SKLM scheduler XA Datasource
dataSourceId = AdminConfig.list('DataSource', 'SKLM scheduler XA Datasource*')
returnCode = update_sklm_datasource(dataSourceId, "SKLM scheduler")

print "Debug --> return from update_sklm_datasource SKLM scheduler XA Datasource  : " + returnCode
if (returnCode == SUCCESS):
		AdminConfig.save( )
#endIf