#!/bin/sh

CURR_DIR=`pwd`
CURR_DIR=${0%/*}
#echo "CURR_DIR=${CURR_DIR}"

export PATH=${PATH}:.

cd ${0%/*}

usage()
{
echo Usage: 
echo		encrypt.sh \"Path to WAS_HOME\" \"String to Encrypt\"
echo		where
echo		the First Input Parameter is the path to WAS_HOME.
echo		and Second Input Parameter is the String to Encrypt.
echo Example: 
echo		encrypt.sh \"/opt/IBM/WebSphere/AppServer\" encryptme
echo Note:	Please ensure the WAS HOME path is correct.
}

if [ "$#" -ne 2 ]
then
usage	
exit 1
fi

if [ ! "$1" ]
then
usage	
exit 1
fi

if [ ! "$2" ]
then
usage
exit 1
fi

export WAS_HOME=$1
echo WAS_HOME=${WAS_HOME}

export ENCRYPT_STRING=$2
echo ENCRYPT_STRING=${ENCRYPT_STRING}

if [ ! -d ${WAS_HOME} ]
then
echo "WAS_HOME Path Invalid"
exit 1
fi

export JAVA_HOME=${WAS_HOME}/java/8.0

if [ ! -d ${JAVA_HOME} ]
then
echo "JAVA_HOME ${JAVA_HOME} is not directory. Check your WAS HOME"
exit 1
fi

ENCRYPT_CP=${CURR_DIR}/com.ibm.tklm.encryption.obfuscation.jar

${JAVA_HOME}/bin/java -cp ${ENCRYPT_CP} com.ibm.tklm.obfuscation.utils.Encrypter "${ENCRYPT_STRING}" > encrypt.log 2>&1
rc=$?
if [ $rc -eq 0 ]; then
    echo  "Encryption Done."
else
    echo  "Problem in Encryption."
fi

exit 0